'
' Programmer fr XMega32A: Diamex AllAVR auf Com3, USBprog Programmer / AVRisp mkII
'
' $prog &HFF , &HFF , &H00 , &HFF , &H00 , &HFE , &HF7        ' generated. Take care that the chip supports all fuse bytes.
'
' Based on code for
' _____ _                  _ _                  _   _
'/  ___| |                | (_)                | | | |
'\ `--.| |__  _ __ ___  __| |_  __ _ _   _  ___| |_| |_  ___
' `--. \ '_ \| '__/ _ \/ _` | |/ _` | | | |/ _ \ __| __|/ _ \
'/\__/ / | | | | |  __/ (_| | | (_| | |_| |  __/ |_| |_|  __/
'\____/|_| |_|_|  \___|\__,_|_|\__, |\__,_|\___|\__|\__|\___|
'                                 | |
'                                 |_|
'
'             By William Thielicke(w.th@gmx.de)

'                                                  Propellerdrehsinn              Propellerdrehsinn
'     ____________________________________         ->              <-
'    |                                    |        __              __
'    |   Shrediquette NANO QUADROCOPTER   |       /  \            /  \               ->        <-
'    |            _      _   _____        |     /      \        /      \
'    |           | \    | |/   _   \      |    |        |      |        |            (X)      (X)
'    |           |  \   | |  /   \  |     |     \      /        \      /                \ __ /
'    |     _    _|   \  | | |     | |     |       \__/  ________  \__/                   |/\|
'    |    | \  / | |\ \ | | |     | |     |            |        |                        |__|
'    |     \ \/ /| | \ \| | |   /\| |     |            |   /\   |                       /    \
'    |     / /\ \| |  \   |  \ _\  \      |            |        |                    (X)      (X)
'    |    |_/  \_|_|   \ _|\ _____\/      |        <-  |        |  ->
'    |                                    |        __  |________|  __                ->        <-
'    |        by  Harald Sattler          |       /  \            /  \
'    | ---------------------------------- |     /      \        /      \
'    | Basis: Williams Shrediquette-Code  |    |        |      |        |
'    | und Erweiterungen von Nils Tholen  |     \      /        \      /
'    |____________________________________|       \__/            \__/
'


'QUADROCOPTER Firmware Xmega MPU-6000

' display GUI-Data even if Motors are running. Useful to determine the impact of motor vibrations on sensor data
' Run_gui = 0 means: no display with running motors - use this for flying
' Run_gui = 1 means: update GUI with running motors - DO NOT use this for flying, control loop may slow down
Const Run_gui = 0

' Versioninfo. Letzte Stelle wird automatisch beim Compilieren inkrementiert
' (dient mir als Zhler fr Flash-Vorgnge, deshalb nicht rcksetzen).    Info: Nicht jeder Compile-Durchgang wird auch geflasht.
$version 1,2,143
Dim Buildinfo As String * 20
Buildinfo = Version(1)                                      ' enthlt Datum und Uhrzeit des Erstellzeitpunkts
Dim Vstring As String * 30
Dim Tempstring As String * 30
Dim Tslen As Byte

'===CHIP SETTINGS===
$regfile = "xm32a4def.dat"
$crystal = 32000000
$framesize = 128
$hwstack = 128
$swstack = 128
$lib "xmega.lib"
$external _xmegafix_clear
$external _xmegafix_rol_r1014
Config Osc = Disabled , 32mhzosc = Enabled
Config Sysclock = 32mhz , Prescalea = 1 , Prescalebc = 1_1
Config Eeprom = Mapped

'===Receiver Anschluss===
Config Pinb.2 = Input
On Portb_int0 Getreceiver
Enable Portb_int0 , Hi                                      ' lo    (Hi/Lo bezieht sich auf die INT priority, _nicht_ auf die Signalflanke)

Portb_pin2ctrl = &B00_011_001
Portb_int0mask = &B0000_0100
Portb_intctrl = &B0000_00_01

'===Timer fr Receiver-Abtastung (Summensignal des Deltang Rx31 oder Infrarot)===
Config Tcc0 = Normal , Prescale = 256 , Resolution = Normal
On Tcc0_ovf Detectrxpause                                   ' erkennt die lange Pause zwischen zwei Impulszgen -> Channel = 0
                                 ' wieso auf 0 ??? -> weil der Wert fr Channel 1 erst mit dem zweiten Impuls festgelegt wird
Enable Tcc0_ovf , Hi                                        ' lo    (Hi/Lo bezieht sich auf die INT priority, _nicht_ auf die Signalflanke)

'===SERIAL COMM zur GUI===
Config Com1 = 38400 , Mode = Asynchroneous , Parity = None , Stopbits = 1 , Databits = 8       'GUI UART
Open "com1:" For Binary As #1
Config Serialout = Buffered , Size = 254                    ' Serialout bezieht sich auf COM1, Serialout1 auf COM2, usw.
Config Serialin = Buffered , Size = 254

'===Versioninfo ausgeben===
Vstring = Version(2)
Print "Version " ; Vstring

Tempstring = "Build " + Buildinfo
Tslen = Len(tempstring ) - 3                                ' Sekunden abschneiden
Tempstring = Left(tempstring , Tslen )
Print Tempstring


'===IC zum MPU60x0===
Dim Twi_start As Byte
Open "twie" For Binary As #3
Config Twie = 400000

' AD0 des MPU ist beim xNQ high, AD0=1
Const Mpuaddw = &HD2                                        ' Device adr. = 69H (as 7bit adr), write adr = D2  (LSB = 0)
Const Mpuaddr = &HD3                                        ' Device adr. = 69H (as 7bit adr), Read adr = D3 (LSB = 1)
' 69H = 0110 1001 , 110 1001 as 7bit, shift left 1 -> 1101 001x mit x=0 fr write, x=1 fr read (x=LSB)
'Const Mpuaddw = &B11010000                                  'AD0 auf Masse    (Willas Setup)
'Const Mpuaddr = &B11010001

'===PORTs fr LEDs===
Config Portc.4 = Output                                     'led rot
Config Portc.5 = Output                                     'led blau
Config Portd.6 = Output                                     'led gelb
Config Portd.7 = Output                                     'led grn (gibt es am xNQ nicht)
Led_red Alias Portc.4
Led_blue Alias Portc.5
Led_yellow Alias Portd.6
Led_grn Alias Portd.7
Config Porta.6 = Output                                     'LED 1 Positionslichter vorne (Blau)
Config Porta.7 = Output                                     'LED 2 Positionslichter hinten (Rot)
' xNQ mit AP-02 hat keine Positions-LEDs, die Motoren decken die Einbaupltze der LEDs ab
' daher werden die Postions-LEDs auf die blaue bzw. rote LED gemappt um Rckmeldungen zu Toggle-Commands geben zu knnen
'Led_vorn Alias Porta.6
'Led_hinten Alias Porta.7
Led_vorn Alias Portc.5
Led_hinten Alias Portc.4


Speakerport Alias Portb.2

' Hinweis: Kanalzuordnung
'Throttle = Sempf(1)
'Roll     = Sempf(2)
'Nick     = Sempf(3)
'Yaw      = Sempf(4)
'Switch1  = Sempf(5)
'Switch2  = Sempf(6)

'=== MOTOR PWM===
' dummerweise habe ich die Motor-PPM-Ausgnge falsch verteilt. 1,2,3,4 sind per Pad verdrahtbar,
' 3,4,5,6 wre besser gewesen, dann lgen alle 4 PWMs auf einem Timer. So brauche ich leider zwei Timer
Config Tcd0 = Pwm , Prescale = 1 , Comparea = Disabled , Compareb = Disabled , Comparec = Enabled , Compared = Enabled , Event_source = Off , Event_action = Off , Event_delay = Disabled , Resolution = Normal
Config Tcd1 = Pwm , Prescale = 1 , Comparea = Enabled , Compareb = Enabled , Event_source = Off , Event_action = Off , Event_delay = Disabled , Resolution = Normal

'motoren aus:
Tcd0_ccc = 29000
Tcd0_ccd = 29000
Tcd1_cca = 29000
Tcd1_ccb = 29000

'===Spannungsmessung===
'Configure ADC of Port A in FREE running mode
Config Adca = Free , Convmode = Unsigned , Resolution = 12bit , Dma = Off , _
Reference = Intvcc , Event_mode = None , Prescaler = 256 , Ch0_gain = 1 , Ch0_inp = Single_ended , Mux0 = 0
Config Pina.0 = Input                                       ' Messeingang der Akkuspannung, mit Spannungsteiler 1:1


'===STARTUP===
I2cinit #3                                                  ' IC-Kommunikation zum MPU60x0
Config Priority = Static , Vector = Application , Lo = Enabled , Med = Enabled , Hi = Enabled       ' Interrupts konfigurieren

'===DECLARATIONS===
'--Global--
Dim I As Word                                               'counter var
Dim B As Byte , C As Byte , Ac As Byte                      'counter var
Dim Lf As Single                                            'stick sensitivity
Dim Motors_on As Bit                                        'self explanatory, right...?!
Dim State As Byte                                           'Contains selected control loop state: 0 = Motors off, 1 = Acrobatic mode, 2 = Hover mode
Dim Old_state As Byte                                       'Contains the state of the last cycle
Dim Led_gelb_merker As Byte

'--Read Deltang receiver --
Dim Empftmp(8) As Word                                      ' maximal 8 Kanle
Dim Channel As Byte                                         'current channel to be read out
Dim Empf(8) As Integer                                      'data from getreceiver interrupt

'--Read receiver --
Dim Failure As Byte
Dim Sempf(8) As Integer                                     ' Zwischenspeicher damit im INT neue Daten die alte nnciht berschreiben

Dim Ms_1_i As Single                                        'contains motor nominal value as integer
Dim Ms_2_i As Single                                        'contains motor nominal value as integer
Dim Ms_3_i As Single                                        'contains motor nominal value as integer
Dim Ms_4_i As Single                                        'contains motor nominal value as integer

Dim Ms_1 As Word                                            'converts motor nominal value to WORD
Dim Ms_2 As Word                                            'converts motor nominal value
Dim Ms_3 As Word                                            'converts motor nominal value
Dim Ms_4 As Word                                            'converts motor nominal value

'--MPU6000--
Dim Test As Byte
Dim Gyrox As Integer
Dim Gyroy As Integer
Dim Gyroz As Integer
Dim Tmp_gyrox(2) As Byte At Gyrox Overlay                   'nick
Dim Tmp_gyroy(2) As Byte At Gyroy Overlay                   'roll
Dim Tmp_gyroz(2) As Byte At Gyroz Overlay                   'yaw
Dim Xacc_pre As Integer
Dim Yacc_pre As Integer
Dim Zacc_pre As Integer
Dim Tmp_accx(2) As Byte At Xacc_pre Overlay
Dim Tmp_accy(2) As Byte At Yacc_pre Overlay
Dim Tmp_accz(2) As Byte At Zacc_pre Overlay
Dim Meas_nick As Single
Dim Meas_roll As Single
Dim Yaw_gyro As Single
Dim Xacc As Single
Dim Yacc As Single
Dim Zacc As Single
Dim Xacc_s As Single
Dim Yacc_s As Single
Dim Zacc_s As Single
Dim Rollstick As Single
Dim Nickstick As Single

Dim S As String * 60                                        ' fr formatierte Ausgabe von Werten
Dim S1 As String * 60                                       ' fr formatierte Ausgabe von Werten

Dim Ln_accx As Integer                                      ' fr ACC Level lernen
Dim Ln_accy As Integer
Dim Learn_accx(2) As Byte At Ln_accx Overlay
Dim Learn_accy(2) As Byte At Ln_accy Overlay

'neu acc winkelberechnung
Dim Xacc_lp As Single
Dim Yacc_lp As Single
Dim Zacc_lp As Single
Dim Xacc_norm As Single
Dim Yacc_norm As Single
Dim Zacc_norm As Single
Dim Tmp1 As Single
Dim Tmp2 As Single
Dim Tmp3 As Single
Dim Tmp4 As Single
Dim Tmp5 As Single
Dim Tmp6 As Single
Dim Tmp7 As Single
Dim Acc_roll As Single
Dim Acc_nick As Single
Dim Acc_nick_temp As Single
Dim Acc_roll_temp As Single
Dim Acc_roll_scaled As Single
Dim Acc_nick_scaled As Single
Dim Print_a As Single
Dim Print_b As Single
Dim Print_a_string As String * 7
Dim Print_b_string As String * 7

'--Gyros--
Dim Roll_init As Single                                     'gyro offset
Dim Nick_init As Single                                     'gyro offset
Dim Yaw_init As Single                                      'gyro offset
Dim Roll_check(16) As Single                                'gyro offset
Dim Nick_check(16) As Single                                'gyro offset
Dim Yaw_check(16) As Single                                 'gyro offset   '!!!!!!!!!   ziemlich gross... ntig??  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
Dim Checkdiff As Single

Dim Setpoint_roll As Single                                 'Stick position
Dim Error_roll As Single                                    'Stick position - current position
Dim Error_roll_sum As Single                                'Integral of the above
Dim Meas_angle_roll As Single                               'the angle of the copter including acc signal (only in Hover mode)

Dim Setpoint_nick As Single                                 'Stick position
Dim Error_nick As Single                                    'Stick position - current position
Dim Error_nick_sum As Single                                'Integral of the above
Dim Meas_angle_nick As Single                               'the angle of the copter including acc signal (only in Hover mode)

Dim P_set_roll As Single                                    'P output including scaling (gain)
Dim I_set_roll As Single                                    'I output including scaling (gain)
Dim D_set_roll As Single                                    'D output including scaling (gain)

'Dim P_set_roll_int As Integer                               'converts to integer
'Dim I_set_roll_int As Integer                               'converts to integer
'Dim D_set_roll_int As Integer                               'converts to integer

Dim Roll_sgl As Single                                      'combination of PID
Dim Nick_sgl As Single                                      'combination of PID
Dim Yaw_sgl As Single                                       'combination of PID

Dim P_set_nick As Single                                    'P output including scaling (gain)
Dim I_set_nick As Single                                    'I output including scaling (gain)
Dim D_set_nick As Single                                    'D output including scaling (gain)

'Dim P_set_nick_int As Integer                               'converts to integer
'Dim I_set_nick_int As Integer                               'converts to integer
'dim D_set_nick_int As Integer                               'converts to integer

Dim Yaw_gyro_i As Single                                    'Integer                                   'yaw gyro var
Dim Yaw_gyro_scale As Single                                'scaled-down values
'Dim Yaw_gyro_scale_int As Integer                           'converts to integer
Dim Yaw_gyro_i_scale As Single                              'scaled-down values
'Dim Yaw_gyro_i_scale_int As Integer                         'converts to integer

Dim P_sens As Single                                        'roll/nick P control loop sensitivity
Dim I_sens As Single                                        'roll/nick I control loop sensitivity
Dim D_sens As Single                                        'roll/nick D control loop sensitivity
Dim Yaw_p_sens As Single                                    'yaw P sensitivity
Dim Yaw_i_sens As Single                                    'yaw I sensitivity

Dim Gyro_i_enable As Bit                                    '0 or 1: don't perform gyro integration when motors off

Dim Error_nick_d(16) As Single
Dim Error_roll_d(16) As Single
Dim Error_nick_old(16) As Single
Dim Error_roll_old(16) As Single
Dim Looper As Byte
Dim P_sens_acro As Single                                   'PID-Parameter fr Regelung
Dim I_sens_acro As Single
Dim D_sens_acro As Single
Dim P_sens_hover As Single
Dim I_sens_hover As Single                                  'Double
Dim D_sens_hover As Single
Dim New_pid_val As Single
Dim New_pid_val_d As Double
Dim New_idle_val As Word
Dim Lf_acro As Single
Dim Lf_hover As Single                                      'Var(18) * 1.16             'alt *4
Dim Lf_yaw As Single                                        '2.586     'Var(19) / 58    'alt /17

Dim P_sens_acro_ee As Eram Single                           'PID-Parameter im EEPROM fr Regeleung
Dim I_sens_acro_ee As Eram Single
Dim D_sens_acro_ee As Eram Single
Dim P_sens_hover_ee As Eram Single
Dim I_sens_hover_ee As Eram Single                          'Double
Dim D_sens_hover_ee As Eram Single
Dim Lf_acro_ee As Eram Single
Dim Lf_hover_ee As Eram Single
Dim Lf_yaw_ee As Eram Single
Dim Idle_up_ee As Eram Word

Dim Dd_sens As Single
Dim Dd_set_nick As Single
Dim Dd_set_roll As Single
Dim Dd_set_nick_int As Single                               'integer
Dim Dd_set_roll_int As Single                               'Integer

'--Acc--
Dim Accy_temp As Single                                     'used for complementary filtering
Dim Accx_temp As Single                                     'used for complementary filtering

'--Mixer--
Dim Vorwahl As Single                                       'throttle idle up
Dim Yaw_diff As Single                                      'Integer        'yaw gyro var

'--Voltage Check--
Dim Spann As Word                                           'reads voltage from adc
Dim Spannmittel As Single                                   'used for filtering
Dim Spann_alt As Word                                       'used for filtering (alt is german and means "old")
Dim Spann_alt2 As Word                                      'used for filtering
Dim Spann_alt3 As Word                                      'used for filtering
Spann_alt = 1023                                            'prepare the filter
Spann_alt2 = 1023                                           'prepare the filter
Spann_alt3 = 1023                                           'prepare the filter
Dim Lowvoltage As Bit                                       'will be 1 if voltage is low

'--LEDs--
Dim Ledcount As Word                                        'used for bling bling
Dim Blinker As Word
Dim Blip As Byte                                            'used for stick magic annotation

'--Speaker--
Dim Speakeron As Bit                                        'Nils-Speaker   speaker ein hilfsbit
Dim Speakerduration As Byte                                 'Nils-Speaker   Dauer wie lange der speaker piepen soll
Dim Speakercount As Byte                                    'Nils-Speaker
Dim Speakerbeeps As Integer                                 'Nils-Speaker   Anzahl Beeps
Dim Silencecount As Byte                                    'Nils-Speaker: Stillezyklenzhler
Dim Silenceduration As Byte                                 'Nils-Speaker: Stille Dauer
Dim Command_speaker_off_bo As Bit                           'Nils-Speaker: Speaker Ruhe

'--XY-Calibration--
Dim Modification As Bit                                     'Nils-XY Offset / Hans
Dim Switch_validation As Bit                                'Nils-XY Offset / Hans
Dim Xy_calibration_bo As Bit                                'Nils-XY Offset
Dim Rescale_bo As Bit                                       'Rescaling of Inputs

'--Functionswitchcommandbits--
Dim Command_xy_calibrate_bo As Bit                          'Nils-XY Offset
Dim Command_rescale_bo As Bit                               'Nils Rescaling of Inputs
Dim Functionactivated_bo As Bit                             'Switching commandbit
Dim Functiondeactivated_bo As Bit                           'Switching commandbit

'--GUI Connection--
Dim A As String * 8                                         ' die meinsten Werte werden beim xNQ nicht verwendet
Dim Read_empfangen As Byte                                  ' und irgendwo anders abgespeichert oder geladen
Dim Reset_empfangen As Byte                                 ' diese Defines werden nur fr deu GUI connection bentigt
Dim Sensors_empfangen As Byte                               ' um das Handshake zu ermglichen
Dim Input_empfangen As Byte

Dim Var(33) As Integer
Dim Eramvariable(33) As Eram Integer

Dim Sensor(13) As Byte
Dim Motorsenable As Byte
Dim Roll_gyro_dir As Byte
Dim Nick_gyro_dir As Byte
Dim Yaw_gyro_dir As Byte
Dim Xacc_dir As Byte
Dim Yacc_dir As Byte
Dim Yaw_p_sens_eep As Single
Dim Yaw_i_sens_eep As Single
Dim Acc_influence As Single
Dim Gyro_influence As Single
Dim Xacc_scale As Integer
Dim Yacc_scale As Integer
Dim Lf_boost As Byte
Dim Idle_up As Word
Dim Voltage_warn As Single
Dim Xacc_offset As Integer
Dim Yacc_offset As Integer
Dim Meas_roll_gui As Single
Dim Meas_nick_gui As Single
Dim Yaw_gyro_gui As Single
Dim Xacc_gui As Single
Dim Yacc_gui As Single
Dim Meas_angle_roll_gui As Single
Dim Meas_angle_nick_gui As Single
Dim Sempf_gui(5) As Single
Dim Voltage_gui As Single
Dim Throttlechannel As Byte
Dim Nickchannel As Byte
Dim Rollchannel As Byte
Dim Yawchannel As Byte

Dim Debugger As Word

'--Subs--
Declare Sub Mixer                                           'prepare all signals for motors and servo
Declare Sub Gyro                                            'read and prepare gyro's
Declare Sub Acc                                             'read and rescale accelerometer
Declare Sub Led                                             'bling bling
Declare Sub Send_mots                                       'check and reshape motor signals and send them via i2c
Declare Sub Read_mpu
Declare Sub Init_mpu
Declare Sub Guiconnection
Declare Sub Geteeprom
Declare Sub Voltage
Declare Sub Speaker
Declare Sub Autooffset
Declare Sub Functionswitcher
Declare Sub Debugout

'===START CONDITIONS===

'--Variables--                                              'prepare some variables
Motors_on = 0
State = 0                                                   'States: 0=GUI, 1=Acro, 2=Hover
Ledcount = 1
Gyro_i_enable = 0

'--Startup 2--
Enable Interrupts

Led_blue = 0
Led_yellow = 0
Led_red = 0

' Mit der Brechstange (dreimal) die MPU-Register beschreiben...
Waitms 200
Init_mpu
Waitms 200
Init_mpu
Waitms 200
Init_mpu
Waitms 200

'--Load and process settings from eeprom--
' eventuell wieder ausbauen, die Params werden momentan sowieso fest im nachfolgenden Code gesetzt
Geteeprom
'... aber ohne maunzt Willas GUI und will immer wieder Parameter aus Datei laden

'vars von Hand einstellen
'faktoren ausrechnen...
'gyros haben identische auflsung
'motor vorher: 0-255
'nachher 29000 - 60200 = 31200
'alle motorwerte 122 dach hochskalieren...
Motorsenable = 1                                            'Var(1)
Roll_gyro_dir = 1
Nick_gyro_dir = 0
Yaw_gyro_dir = 1

'IMAV parameter aus GUI: P 80/255 I 125/25500 D 33/50 =
'P 0.313
'I 0.0049
'D 0.66
'indoor gut P 0.22
'i 0.002
'd 1

 Const Pid_code = 0
#if Pid_code = 1                                            ' PID-Paprams im Code festgelegt
   P_sens_acro = 0.18                                       ' 0.313                                         '0.313                                         'Var(7) / 255
   I_sens_acro = 0.0019                                     '0.0007                                        '0.0049                                        'Var(8) / 25500
   D_sens_acro = 0.2                                        '0.85
   'wenn im wind schiet, I evtl. auf 0.001 D auf 0.5 verkleinern

   'hover schwingt noch etwas. D hoch? oder runter...? oder besser I?

   P_sens_hover = 0.0013
   I_sens_hover = 0.000000033                               'das scheint ganz ok....                                            '
   'war ok als hover i:'0.00000001
   D_sens_hover = 0.18                                      '0.18 0.18
#else                                                       ' PID-Params aus EEPROM verwenden
   P_sens_acro = P_sens_acro_ee
   I_sens_acro = I_sens_acro_ee
   D_sens_acro = D_sens_acro_ee
   P_sens_hover = P_sens_hover_ee
   I_sens_hover = I_sens_hover_ee
   D_sens_hover = D_sens_hover_ee

   Lf_acro = Lf_acro_ee
   Lf_hover = Lf_hover_ee
   Lf_yaw = Lf_yaw_ee
   Idle_up = Idle_up_ee

   '===Abfangen, dass alle PID-Parameter im EEPROM Null sind
   If P_sens_acro = 0 And I_sens_acro = 0 And D_sens_acro = 0 And P_sens_hover = 0 And I_sens_hover = 0 And D_sens_hover = 0 Then
      P_sens_acro = 0.07                                    ' mit xNQ erflogene Werte
      I_sens_acro = 0.00035
      D_sens_acro = 0.04
      P_sens_hover = 0.0006
      I_sens_hover = 0.000000033
      D_sens_hover = 0.04

      Lf_acro = 2.9                                         ' noch tunen
      Lf_hover = 160                                        '
      Lf_yaw = 3.5
      Idle_up = 30

      P_sens_acro_ee = P_sens_acro
      I_sens_acro_ee = I_sens_acro
      D_sens_acro_ee = D_sens_acro
      P_sens_hover_ee = P_sens_hover
      I_sens_hover_ee = I_sens_hover
      D_sens_hover_ee = D_sens_hover
      Lf_acro_ee = Lf_acro
      Lf_hover_ee = Lf_hover
      Lf_yaw_ee = Lf_yaw
      Idle_up_ee = Idle_up
   End If

   For C = 0 To 20
      If Ischarwaiting(#1) = 1 Then
         Do
            Print "PID-Parameter einstellen"
            Print "========================"
            Print
            Print "Aktuell im EEPROM:"
                  S = Fusing(p_sens_acro , "##.########")
            Print "1 - P_sens_acro " ; S
                  S = Fusing(i_sens_acro , "##.########")
            Print "2 - I_sens_acro " ; S
                  S = Fusing(d_sens_acro , "##.########")
            Print "3 - D_sens_acro " ; S
                  S = Fusing(p_sens_hover , "##.########")
            Print "4 - P_sens_hover " ; S
'                  S = Fusing(i_sens_hover , "##.########")
                  S = Str(i_sens_hover , "##.########")
            Print "5 - I_sens_hover " ; S
                  S = Fusing(d_sens_hover , "##.########")
            Print "6 - D_sens_hover " ; S
                  S = Fusing(lf_acro , "##.########")
            Print "7 - Lf_acro " ; S
                  S = Fusing(lf_hover , "##.########")
            Print "8 - Lf_hover " ; S
                  S = Fusing(lf_yaw , "##.########")
            Print "9 - Lf_yaw " ; S
                  S = Str(idle_up , "##.########")
            Print "0 - Idle_up " ; S
            Print
            Print "Aendern: a, Abbruch: b, Fertig: f, Defaults: d"

            A = Waitkey(#1)                                 ' A ist String(8)
            Ac = Asc(a)
            Print                                           ' Leerzeile

            Select Case Ac
               Case 97:                                     ' a - ndern
                  Print "Welchen Wert aendern? [1..9,0]"
                  B = Waitkey(#1)
                  Print                                     ' Leerzeile
                  Select Case B
                     Case 49:                               ' 1
                        Print "P_sens_acro, alter Wert: " ; Str(p_sens_acro )
                        Input "P_sens_acro, neuer Wert: " , New_pid_val
                        If New_pid_val <> P_sens_acro Then
                           P_sens_acro_ee = New_pid_val
                           P_sens_acro = New_pid_val        ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 50:                               ' 2
                        Print "I_sens_acro, alter Wert: " ; Str(i_sens_acro )
                        Input "I_sens_acro, neuer Wert: " , New_pid_val
                        If New_pid_val <> I_sens_acro Then
                           I_sens_acro_ee = New_pid_val
                           I_sens_acro = New_pid_val        ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 51:                               ' 3
                        Print "D_sens_acro, alter Wert: " ; Str(d_sens_acro )
                        Input "D_sens_acro, neuer Wert: " , New_pid_val
                        If New_pid_val <> D_sens_acro Then
                           D_sens_acro_ee = New_pid_val
                           D_sens_acro = New_pid_val        ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 52:                               ' 4
                        Print "P_sens_hover, alter Wert: " ; Str(p_sens_hover )
                        Input "P_sens_hover, neuer Wert: " , New_pid_val
                        If New_pid_val <> P_sens_hover Then
                           P_sens_hover_ee = New_pid_val
                           P_sens_hover = New_pid_val       ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 53:                               ' 5
                        Print "I_sens_hover, alter Wert: " ; Str(i_sens_hover )
                        Input "I_sens_hover, neuer Wert: " , New_pid_val
                        If New_pid_val <> I_sens_hover Then
                           I_sens_hover_ee = New_pid_val
                           I_sens_hover = New_pid_val       ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 54:                               ' 6
                        Print "D_sens_hover, alter Wert: " ; Str(d_sens_hover )
                        Input "D_sens_hover, neuer Wert: " , New_pid_val
                        If New_pid_val <> D_sens_hover Then
                           D_sens_hover_ee = New_pid_val
                           D_sens_hover = New_pid_val       ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 55:                               ' 7
                        Print "Lf_acro, alter Wert: " ; Str(lf_acro )
                        Input "Lf_acro, neuer Wert: " , New_pid_val
                        If New_pid_val <> Lf_acro Then
                           Lf_acro_ee = New_pid_val
                           Lf_acro = New_pid_val            ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 56:                               ' 8
                        Print "Lf_hover, alter Wert: " ; Str(lf_hover )
                        Input "Lf_hover, neuer Wert: " , New_pid_val
                        If New_pid_val <> Lf_hover Then
                           Lf_hover_ee = New_pid_val
                           Lf_hover = New_pid_val           ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 57:                               ' 9
                        Print "Lf_yaw, alter Wert: " ; Str(lf_yaw )
                        Input "Lf_yaw, neuer Wert: " , New_pid_val
                        If New_pid_val <> Lf_yaw Then
                           Lf_yaw_ee = New_pid_val
                           Lf_yaw = New_pid_val             ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case 48:                               ' 0
                        Print "Idle_up, alter Wert: " ; Str(idle_up )
                        Input "Idle_up, neuer Wert: " , New_idle_val
                        If New_idle_val <> Idle_up Then
                           Idle_up_ee = New_idle_val
                           Idle_up = New_idle_val           ' nach nderung die neuen Werte auch in die Variable speichern
                        End If
                     Case Else:                             ' B < 0 oder B > 9
                        Print B
                  End Select
               Case 98:                                     ' b - abbruch
               Case 100:                                    ' d - defaults ins EEPROM schreiben
                  P_sens_acro = 0.07                        ' mit xNQ erflogene Werte
                  I_sens_acro = 0.00035
                  D_sens_acro = 0.04
                  P_sens_hover = 0.0006
                  I_sens_hover = 0.000000033
                  D_sens_hover = 0.04

                  Lf_acro = 2.9                             ' noch tunen
                  Lf_hover = 160                            '
                  Lf_yaw = 3.5
                  Idle_up = 30

                  P_sens_acro_ee = P_sens_acro
                  I_sens_acro_ee = I_sens_acro
                  D_sens_acro_ee = D_sens_acro
                  P_sens_hover_ee = P_sens_hover
                  I_sens_hover_ee = I_sens_hover
                  D_sens_hover_ee = D_sens_hover
                  Lf_acro_ee = Lf_acro
                  Lf_hover_ee = Lf_hover
                  Lf_yaw_ee = Lf_yaw
                  Idle_up_ee = Idle_up
               Case 102:                                    ' f - fertig
                  Exit Do
               Case Else:
            End Select
         Loop
      Else
         Toggle Led_yellow
         Waitms 100
      End If
   Next C
   Reset Led_yellow
   Print
   Print "Aenderungen beendet"
#endif

Dd_sens = 0                                                 ' 0.2
Yaw_p_sens_eep = 0.4                                        '0.1                                        '0.7843                                     ' Var(12) / 255
Yaw_i_sens_eep = 0.001                                      '0.00005                                    '0.00196                                    ' Var(13) / 25500

'bei 0 acc influence fliegts ruhig.
'd.h. der acc hat ein assym offset bei versch. drehzahlen.
'--> besser imu dmpfen?
'oder liegts daran, dass nicht 100% gerade eingebaut? Also winkel Offset einbauen?
'verschiedene ACC Auflsungen testen. in init_MPU und hier drunter anpassen 2g am besten...?
'hover i weniger?

Const Scalefactoracc = 16384                                '=32768 / 2   '2g acc
'Const Scalefactoracc = 8192                                 '=32768 / 4   '4g acc
'Const Scalefactoracc = 4096                                 '=32768 / 8   '8g acc
'Const Scalefactoracc = 2048                                 '=32768 / 16   '16g acc

Acc_influence = 0.0016                                      '0.00035 '0.0016
Gyro_influence = 1 - Acc_influence
'Const Lf_acro = 1.1                                         '1.25      'Var(17) / 88    'alt /25.5
'Const Lf_hover = 160                                        'Var(18) * 1.16             'alt *4
'Const Lf_yaw = 2.8                                          '2.586     'Var(19) / 58    'alt /17
' Konstanten in Variablen wandeln und im EEPROM ablegen

' Vollausschlag ADC ist 4096 (12 bit)
' Spannungsteiler 10k/10k, Referenz ist "Intvcc", also nach Datenblatt VCC/1,6 = 3,3 V/1,6 = 2,0625 V
' Ref = 2,0625 V <-> 4096
' 0,50354 mV / Digit -> 3,8 V <->
' gemessene Werte: 4,2 V -> 2047, 3,8 V  -> 1996, 3,6 V -> 1904
Voltage_warn = 1904                                         '3,6 V Warngrenze fr 1S LiPo-Akku  'Var(22) * 4


'=== Measure ACC Offset (don't move copter now!) ===
'X-Achse sollte roll sein
Xacc_offset = Eramvariable(23)                              'Var(23)
'Y-Achse sollte nick sein
Yacc_offset = Eramvariable(24)                              'Var(24)

'For I = 1 To 16                                            ' nicht hier messen, sondern Werte aus EEPROM holen und verwenden
'    Read_mpu

'    Xacc_offset = Xacc_offset + Xacc_pre                    ' Mittelwert von 16 Messungen bilden
'    Xacc_offset = Xacc_offset / 2
'    Yacc_offset = Yacc_offset + Yacc_pre
'    Yacc_offset = Yacc_offset / 2
'    Waitms 100
'Next

Xacc_lp = Xacc_offset                                       ' vorbelegen
Yacc_lp = Yacc_offset                                       ' vorbelegen

  Print "Xacc_offset " ; Xacc_offset
  Print "Yacc_offset " ; Yacc_offset

Failure = 10
Sempf(5) = -35
Sempf(throttlechannel) = 0

For I = 1 To 6
   Waitms 200
   Toggle Led_blue
Next I


'=== Measure Gyro Offset (don't move copter now!) ===
Gyro_offset:
Roll_init = 0
Nick_init = 0
Yaw_init = 0
Led_blue = 0
Led_yellow = 0
Led_red = 1

For I = 1 To 16
    Read_mpu

    Roll_init = Roll_init + Meas_roll
    Roll_check(i) = Meas_roll
    Nick_init = Nick_init + Meas_nick
    Nick_check(i) = Meas_nick
    Yaw_init = Yaw_init + Yaw_gyro
    Yaw_check(i) = Yaw_gyro
    Waitms 100
Next

Roll_init = Roll_init / 16
Nick_init = Nick_init / 16
Yaw_init = Yaw_init / 16

For I = 1 To 16
  Checkdiff = Roll_init - Roll_check(i)                     'compare mean value vs individual values
  Checkdiff = Abs(checkdiff)
  If Checkdiff > 3 Then Goto Gyro_offset                    'if individual values differ from mean, then the copter was moved. Redo offset measurement.
  Checkdiff = Nick_init - Nick_check(i)                     'compare mean value vs individual values
  Checkdiff = Abs(checkdiff)
  If Checkdiff > 3 Then Goto Gyro_offset                    'if individual values differ from mean, then the copter was moved. Redo offset measurement.
  Checkdiff = Yaw_init - Yaw_check(i)                       'compare mean value vs individual values
  Checkdiff = Abs(checkdiff)
  If Checkdiff > 3 Then Goto Gyro_offset                    'if individual values differ from mean, then the copter was moved. Redo offset measurement.
Next

Led_blue = 1
Led_red = 0

'==============ESC einlernen====================================================
' Empfnger wird hier bereits abgefragt (Timer und INT)
'
' Start der ESC-Einlernroutine durch Knppel- und Schalter-Voodoo:
'
'   0   1  0   1              SW1: Gear (DX6i)
'      /      /               SW2: Flap (DX6i)
'           
'    SW1    SW2
'     _______       _______
'    |   .   |     |       |
'  G |   |   |   N |       |
'  a |   *   | + i |   *   |  ESC-Einlernen starten
'  s |       |   c |     \ |
'    |_______|   k |_______|
'      Gier          Roll
'
' Der Sender muss so eingestellt sein (Schalter und Knppel) wenn der Empfnger gestartet wird.
' Die ESCs mssen dabei OHNE Spannung sein, drfen erst (EINZELN) versorgt werden, wenn der Sender in der
' Einstellroutine ist (RGB-LEDs blinken gleichzeitig, Positions-LEDs sind aus).
' Bedienung der ESCs (Einlernen und Programmieren) dann per Gas-Knppel wie in der ESC-Anleitung beschrieben.
' Die ESCs knnen hier nacheinander eingestellt werden.

'Empf(X) are filled in "getreceiver". They usually contain values ranging from -52 - +52.
'throttle stick will be rescaled differently
   If Empf(throttlechannel) > -54 And Empf(throttlechannel) < 54 Then       'don't process values that can't be correct
     Sempf(throttlechannel) = Empf(throttlechannel) + 53    ' anheben auf 0..106
     Sempf(throttlechannel) = Sempf(throttlechannel) * 2.4  '==> values ranging from ~2 (stick at bottom) to ~222 (full throttle)
   End If

'Now nick, roll, yaw and idle up switch
   If Empf(nickchannel) > -54 And Empf(nickchannel) < 54 Then       'don't process values that can't be correct
     Sempf(nickchannel) = Empf(nickchannel)                 'convert to values ranging from -54 to +54
   End If
   If Empf(rollchannel) > -54 And Empf(rollchannel) < 54 Then       'don't process values that can't be correct
     Sempf(rollchannel) = Empf(rollchannel)                 'convert to values ranging from -54 to +54
   End If
     If Empf(yawchannel) > -54 And Empf(yawchannel) < 54 Then       'don't process values that can't be correct
     Sempf(yawchannel) = Empf(yawchannel)                   'convert to values ranging from -54 to +54
   End If
   If Empf(5) > -54 And Empf(5) < 54 Then                   'don't process values that can't be correct
     Sempf(5) = Empf(5)                                     'convert to values ranging from -54 to +54
   End If
   If Empf(6) > -54 And Empf(6) < 54 Then                   'don't process values that can't be correct
     Sempf(6) = Empf(6)                                     'convert to values ranging from -54 to +54
   End If

'Print Sempf(5) ; " " ; Sempf(6) ; " " ; Sempf(throttlechannel) ; " " ; Sempf(rollchannel) ; " " ; Sempf(nickchannel)

If Sempf(5) > 50 And Sempf(6) > 50 And Sempf(throttlechannel) > 200 And Sempf(rollchannel) < -45 And Sempf(nickchannel) < -45 Then
   Reset Led_blue
   Set Led_red

   Do                                                       ' hier warten, bis Gas-Knppel auf Null gestellt wurde
      Toggle Led_red
      Toggle Led_blue
      Waitms 200
   Loop Until Empf(throttlechannel) < -48                   ' um hier nicht so lang zu werden empf() verwendet (statt sempf())

   Reset Led_red
   Reset Led_blue

   Ledcount = 0
   Do
      If Empf(throttlechannel) > -54 And Empf(throttlechannel) < 54 Then       'don't process values that can't be correct
        Sempf(throttlechannel) = Empf(throttlechannel) + 53
        Sempf(throttlechannel) = Sempf(throttlechannel) * 2.4       '==> values ranging from 3 (stick at bottom) to 228 (full throttle)
      End If

      ' Semp(1) < 5 oder > 220 fr Stopp und Vollgas
      Ms_1_i = Sempf(throttlechannel)                       ' im 1. Ansatz einfach die Knppelwerte an die ESCs durchreichen

      Ms_1 = Ms_1_i * 147                                   ' alle Motoren werden zum Einlernen gleich angesteuert
      Ms_1 = Ms_1 + 29000
      Ms_2 = Ms_1
      Ms_3 = Ms_1
      Ms_4 = Ms_1

      Tcd0_ccc = Ms_4                                       ' MOT4 im Schaltbild
      Tcd0_ccd = Ms_1                                       ' MOT3 im Schaltbild
      Tcd1_cca = Ms_2                                       ' MOT2 im Schaltbild
      Tcd1_ccb = Ms_3                                       ' MOT1 im Schaltbild

      If Ledcount < 5000 Then
         Incr Ledcount
         If Ledcount = 135 Or Ledcount = 270 Then           'flash Positions-LEDs
            Toggle Led_blue
            Toggle Led_red
         End If
      Else
         Ledcount = 0
         Print Sempf(throttlechannel)
      End If

   Loop Until Empf(5) < -50 And Empf(6) < 10 And Sempf(throttlechannel) < 10
   Reset Led_blue
   Reset Led_red

' Verlassen/Beenden des ESC-Einlernroutine durch:
'  Switch 1 und Switch 2 auf "0" und Gas auf Null
'   _______       _______
'  |       |     |       |
'G |       |   N |       |
'a |   *   | + i |   *   |  ESC-Einlernen beenden
's |   |   |   c |       |
'  |_______|   k |_______|
'    Gier          Roll
'
End If
'==============ESC einlernen====================================================



'==============MAIN LOOP========================================================
'All this does is calling subs in a loop all the time

Do
   Read_mpu
   Acc
   Gyro
   Mixer
   Send_mots
   Led
   Voltage
'   Speaker                                                'Nils-Speaker
   Guiconnection
   Autooffset                                               'Nils-XY Offset
   Functionswitcher                                         'Nils Functionswitchsubroutine

   If Debugger < 100 Then
      Incr Debugger
   Else
      Debugout
      Debugger = 0
   End If

   Toggle Led_grn                                           ' mit dem Oszi die Schleifengeschwindigkeit messen
Loop
End
'==============MAIN LOOP end====================================================

'===Debugout Ausgaben====================================================================
Sub Debugout
'------------------------------------------------
'   Print "Acc_roll_scaled: " ; Acc_roll_scaled ; " Acc_nick_scaled: " ; Acc_nick_scaled
'------------------------------------------------
' Empf() und Sempf()
'   Print
'   Print "Empf(c) " ;
'   For C = 1 To 6
'      S1 = Str(empf(c))
'      S = Format(s1 , "+  ")
'      Print C ; ":" ; S ; " ";
'   Next C
'   Print
'   Print "Sempf(c)";
'   For C = 1 To 6
'      S1 = Str(sempf(c))
'      S = Format(s1 , "+  ")
'      Print C ; ":" ; S ; " ";
'   Next C
'
'------------------------------------------------
' Motor-PWM-Werte
'   Print "Re H:" ; Ms_1_i ; " Re V:" ; Ms_2_i ; " Li V:" ; Ms_3_i ; " Li H:" ; Ms_4_i
'   Print
'   S1 = Str(ms_1_i)
'   S = Fusing(ms_1_i , "##.#")
'                              Print "Re H : " ; S ;
'   S1 = Str(ms_2_i)
'   S = Fusing(ms_2_i , "##.#")
'                              Print "   Re V : " ; S ;
'   S1 = Str(ms_3_i)
'   S = Fusing(ms_3_i , "##.#")
'                              Print "   Li V : " ; S ;
'   S1 = Str(ms_4_i)
'   S = Fusing(ms_4_i , "##.#")
'                              Print "   Li H : " ; S ;
'
'------------------------------------------------
' Gyro und ACC Werte
'   Print
'   S1 = Str(gyrox)
'   S = Format(s1 , "+  ")
'   Print "GX " ; S ; " ";
'   S1 = Str(gyroy)
'   S = Format(s1 , "+  ")
'   Print "GY " ; S ; " ";
'   S1 = Str(gyroz)
'   S = Format(s1 , "+  ")
'   Print "GZ " ; S ; "    ";
' 'entweder:
'   S = Fusing(xacc , "##.#")
'   Print "AX " ; S ; " ";
'   S = Fusing(yacc , "##.#")
'   Print "AY " ; S ; " ";
'   S = Fusing(zacc , "##.#")
'   Print "AZ " ; S ; " ";
' 'oder:
'   S = Fusing(Xacc_norm , "##.#")
'   Print "AX " ; S ; " ";
'   S = Fusing(yacc_norm , "##.#")
'   Print "AY " ; S ; " ";
'   S = Fusing(zacc_norm , "##.#")
'   Print "AZ " ; S ; " ";
'
'------------------------------------------------
' Meas_roll und ACC Meas_nick
'   Print
'   S = Fusing(meas_roll , "##.###")
'   Print "Meas_roll " ; S ; "    ";
'   S1 = Str(yacc)
'   S = Fusing(meas_nick , "##.###")
'   Print "Meas_nick " ; S ; " ";
'
'------------------------------------------------
' xacc_offset, xacc_offset, (Yaw_init)
'   Print
'   S = Str(xacc_offset , "##.###")
'   S1 = Str(xacc_pre)
'   Print "Xacc_offset " ; S ; "  " ; S1 ; "    ";
'   S = Str(yacc_offset , "##.###")
'   S1 = Str(yacc_pre)
'   Print "Yacc_offset " ; S ; "  " ; S1 ; "    ";
'   S = Fusing(yaw_init , "##.###")
'   S1 = Fusing(zacc_s , "##.###")
'   Print "Yaw_init " ; S ; "  " ; S1 ;
'   Print "Yaw_init " ; S ; "  ";
'
'------------------------------------------------


End Sub

'===Functionswitcher====================================================================
'   _______    -  _______
'+ |       |   N |       |
'G |       |   i |       |
'a |   *   | + c |   *   |  XY-Offset starten
's |   |   |   k | /     |
'- |_______|   + |_______|
'   -Gier +       +Roll -
'
'   _______       _______
'  |       |     |       |
'G |       |   N |       |
'a |   *   | + i |   *   |  Piepton quittieren
's |   |   |   c |     \ |
'  |_______|   k |_______|
'    Gier          Roll
'
Sub Functionswitcher

 '--Activate/deactivate XY Calibration--
 If State = 0 And Sempf(rollchannel) > 45 And Sempf(nickchannel) > 45 Then
  Command_xy_calibrate_bo = 1                               'stick ist moved bottom left
 End If

 '--deactivate the beeping speaker--
 If State = 0 And Sempf(rollchannel) < -45 And Sempf(nickchannel) > 45 Then
    Command_speaker_off_bo = 1                              'stick ist moved bottom right
 End If

 'stick back in center position
 If State = 0 And Sempf(rollchannel) > -10 And Sempf(rollchannel) < 10 And _
                  Sempf(nickchannel) > -10 And Sempf(nickchannel) < 10 Then

  If Command_xy_calibrate_bo = 1 Then                       '--Activate/deactivate XY Calibration--
   Toggle Xy_calibration_bo                                 'Activate/deactivate desired function
   Command_xy_calibrate_bo = 0                              'reset command bit
   If Xy_calibration_bo = 1 Then                            'case selection if function turned on or off
    Functionactivated_bo = 1
    Led_gelb_merker = 1                                     ' merken, ob gelbe LED an oder aus war
   Else
    Functiondeactivated_bo = 1
    Led_gelb_merker = 0                                     ' merken, ob gelbe LED an oder aus war
   End If
  End If

  If Command_speaker_off_bo = 1 Then                        '--deactivate the beeping speaker--
   Command_speaker_off_bo = 0                               'reset command bit
   Speakeron = 0                                            'deactivate speaker
  End If
 End If


 '--confirmation beep--
 If Functionactivated_bo = 1 Then                           'case selection if function turned on or off
  Speakeron = 1
  Functionactivated_bo = 0
  Speakerduration = 20                                      'Nils-Speaker: duration of a beep
  Silenceduration = 20                                      'Nils-Speaker: duration of silence between beeps
  Speakerbeeps = 2                                          'Nils-Speaker: Amount of beeps
    For Blip = 0 To 5                                       ' optisches Feedback beim sNQ/xNQ da kein Beeper
      Set Led_vorn                                          ' xNQ: "hinten" = ROT, "vorn" = BLAU
      Waitms 50
      Reset Led_vorn
      Waitms 100
    Next
 End If
 If Functiondeactivated_bo = 1 Then
  Speakeron = 1
  Functiondeactivated_bo = 0
  Speakerduration = 20                                      'Nils-Speaker: duration of a beep
  Silenceduration = 20                                      'Nils-Speaker: duration of silence between beeps
  Speakerbeeps = 3                                          'Nils-Speaker: Amount of beeps
    For Blip = 0 To 5                                       ' optisches Feedback beim sNQ/xNQ da kein Beeper
      Set Led_hinten                                        ' xNQ: "hinten" = ROT, "vorn" = BLAU
      Waitms 50
      Reset Led_hinten
      Waitms 100
    Next
 End If
End Sub

'===Autooffset==================================================================         'Nils-XY Offset
Sub Autooffset
                                                            '
 If State > 0 And Sempf(5) < -20 And Xy_calibration_bo = 1 Then       'Acro or Hover Mode selected  and Switch to idle but still throttle -> Failsave will react
  Xy_calibration_bo = 0
  Led_gelb_merker = 1                                       ' merken, ob gelbe LED an oder aus war
  For I = 1 To 19
      I2cstart #3                                           'X ACC
      I2cwbyte Mpuaddw , #3                                 'write adress of MPU-6050
      I2cwbyte 59 , #3                                      'Register 59 ACCEL_XOUT_H
      I2crepstart #3                                        'repeated start
      I2cwbyte Mpuaddr , #3                                 'read adress of MPU-6050
      I2crbyte Learn_accy(2) , Ack , #3                     'read byte ACCEL_XOUT_H (Reg 59)
      I2crbyte Learn_accy(1) , Ack , #3                     'read byte ACCEL_XOUT_L (Reg 60)
      I2crbyte Learn_accx(2) , Ack , #3                     'read byte ACCEL_YOUT_H (Reg 61)
      I2crbyte Learn_accx(1) , Nack , #3                    'read byte ACCEL_YOUT_L (Reg 62)
      I2cstop #3                                            'stop condition

      Ln_accx = Ln_accx / 64                                ' auf 10 bit schrumpfen
      Ln_accy = Ln_accy / 64                                ' auf 10 bit schrumpfen
      Ln_accx = Ln_accx + 500                               ' (512 +- xx) die gelesenen Werte in die Nhe von 512 skalieren
      Ln_accy = Ln_accy + 500                               ' (512 +- xx) damit Willas Algorithmen stimmen

      Xacc_offset = Xacc_offset + Ln_accx
      Yacc_offset = Yacc_offset + Ln_accy
  Next

  Xacc_offset = Xacc_offset / 20
  Yacc_offset = Yacc_offset / 20
  Modification = 1                                          'New Offset Values are available
  Speakeron = 1                                             'Nils-Speaker: turn on speaker
  Speakerduration = 40                                      'Nils-Speaker: duration of a beep
  Silenceduration = 40                                      'Nils-Speaker: duration of silence between beeps
  Speakerbeeps = 2                                          'Nils-Speaker: amount of beeps

  Print "Xacc_offset " ; Xacc_offset
  Print "Yacc_offset " ; Yacc_offset
  Print "learning new levels"
 End If

 If Ledcount = 500 Then
    Toggle Led_yellow
 End If

 If Modification = 1 And State = 0 And Motors_on = 0 Then   'Nev Values are availabe, idle mode is active and motors are off
   Modification = 0
   Var(23) = Xacc_offset                                    '- 384
   Var(24) = Yacc_offset                                    '- 384
   Eramvariable(23) = Var(23)
   Eramvariable(24) = Var(24)
'   For I = 1 To 33
'   Writeeeprom Var(i) , I                                   'Write to eeprom
'   Next
  Waitms 50
'  Geteeprom                                                 'reread EEPROM
  Speakeron = 1                                             'Nils-Speaker: Beep if Autooffset ended Correctly and eeprom is reread
  Speakerduration = 20                                      'Nils-Speaker: duration of a beep
  Silenceduration = 20                                      'Nils-Speaker: duration of silence between beeps
  Speakerbeeps = 2                                          'Nils-Speaker: Amount ob beeps

'  Led_yellow = Led_gelb_merker
Led_gelb_merker = 0
  Print "Xacc_offset " ; Xacc_offset
  Print "Yacc_offset " ; Yacc_offset
  Print "new levels saved"
 End If
End Sub

' ------------------------------------------------------------------------------
Sub Init_mpu
   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 117 , #3                                        'Register 117 "Who am I"
   I2crepstart #3                                           'repeated start
   I2cwbyte Mpuaddr , #3                                    'read adress of MPU-6050
   I2crbyte Test , Nack , #3                                'read byte WHO_AM_I (Reg 117)
   I2cstop #3                                               'stop condition

' check
   Print "MPU: " ; Test                                     ' Soll: 104
' check

   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 25 , #3                                         'Register 25 Sample Rate Divider (1..8 kHz)
   I2cwbyte &B00000000 , #3                                 'Divider set to 1   (soll)
   'I2cwbyte &B00000111                                       'Divider set to 8
   I2cstop #3                                               'stop condition

   'Low pass filter
   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 26 , #3                                         'Register 26 DLPF_CFG (digital lowpass filter) Configuration
'   I2cwbyte &B00000000 , #3                                 'Bits 0..2 = 000 - ACC:260Hz, 0.0ms; Gyro:256Hz, 0.98ms
'   I2cwbyte &B00000001 , #3                                 'Bits 0..2 = 001 - ACC:184Hz, 2.0ms; Gyro:188Hz, 1.9ms
'   I2cwbyte &B00000010 , #3                                 'Bits 0..2 = 010 - ACC: 94Hz, 3.0ms; Gyro: 98Hz, 2.8ms
   I2cwbyte &B00000011 , #3                                 'Bits 0..2 = 011 - ACC: 44Hz, 4.9ms; Gyro: 42Hz, 4.8ms
'   I2cwbyte &B00000100 , #3                                 'Bits 0..2 = 100 - ACC: 21Hz, 8.5ms; Gyro: 20Hz, 8.3ms
'   I2cwbyte &B00000101 , #3                                 'Bits 0..2 = 101 - ACC: 10Hz,13.8ms; Gyro: 10Hz, 13.4ms
'   I2cwbyte &B00000110 , #3                                 'Bits 0..2 = 110 - ACC:  5Hz,19.0ms; Gyro:  5Hz, 18.6ms
   I2cstop #3                                               'stop condition
                        '42hz scheint gut
   'gyro full range
   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 27 , #3                                         'Register 27 Gyro Configuration
'   I2cwbyte &B00000000 , #3                                 'Bits 3+4 = 00 - Full Scale Range: +/-250/s
   I2cwbyte &B00001000 , #3                                 'Bits 3+4 = 01 - Full Scale Range: +/-500/s
'   I2cwbyte &B00010000 , #3                                 'Bits 3+4 = 10 - Full Scale Range: +/-1000/s
'   I2cwbyte &B00011000 , #3                                 'Bits 3+4 = 11 - Full Scale Range: +/-2000/s
   I2cstop #3                                               'stop condition

   'ACC full range
   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 28 , #3                                         'Register 28 ACC Configuration
   I2cwbyte &B00000000 , #3                                 'Bits 3+4 = 00 - Full Scale Range: +/-2g / No High Pass Filter
'   I2cwbyte &B00001000 , #3                                 'Bits 3+4 = 01 - Full Scale Range: +/-4g / No High Pass Filter
'   I2cwbyte &B00010000 , #3                                 'Bits 3+4 = 10 - Full Scale Range: +/-8g / No High Pass Filter
'   I2cwbyte &B00011000 , #3                                 'Bits 3+4 = 11 - Full Scale Range: +/-16g / No High Pass Filter
   I2cstop #3                                               'stop condition

   I2cstart #3                                              'start condition
   I2cwbyte Mpuaddw , #3                                    'write adress of MPU-6050
   I2cwbyte 107 , #3                                        'Register 107 Power Management 1
   I2cwbyte &B00001011 , #3                                 'No Reset / No Sleep / No Cycle / Temp_Sens: Dis / Clock Source: Z-Gyro
'   I2cwbyte &B00000011 , #3                                 'No Reset / No Sleep / No Cycle / Temp_Sens: Ena / Clock Source: Z-Gyro
   I2cstop #3
End Sub

'--------------------------------------------------------------------------------
' ACHTUNG!! Die im Datenblatt angegebenen Achsen des MPU stimmen so nur fr die Gyros.
' Die Acc-Sensoren sind unterschiedlich ausgerichtet. ACC-X und ACC-Y sind vertauscht.
' D.h.
' Gyros:
' Rollachse = Y, positive Winkel nach rechts
' Nickachse = X, positive Winkel nach hinten
' Yawachse  = Z, positive Winkel nach links / gegen den Uhrzeigersinn gedreht
' Accs:
' Rollachse = X, positive Winkel nach rechts
' Nickachse = Y, positive Winkel nach hinten
' Yawachse  = Z, positive Winkel nach links / gegen den Uhrzeigersinn gedreht
' Daher werden X- und Y-Werte vertauscht auslesen, um Gyros und Accs gleichsinnig behandeln zu knnen

Sub Read_mpu
   I2cstart #3                                              'X ACC
   I2cwbyte Mpuaddw , #3
   I2cwbyte 59 , #3
   I2crepstart #3
   I2cwbyte Mpuaddr , #3                                    ' Achtung!!!  X und Y beim Auslesen vertauschen
   I2crbyte Tmp_accy(2) , Ack , #3                          ' Hier X-Register in Y-Variablen speichern
   I2crbyte Tmp_accy(1) , Ack , #3                          '
   I2crbyte Tmp_accx(2) , Ack , #3                          ' Hier Y-Register in X-Variablen speichern
   I2crbyte Tmp_accx(1) , Ack , #3                          '
   I2crbyte Tmp_accz(2) , Ack , #3
   I2crbyte Tmp_accz(1) , Nack , #3
   I2cstop #3

   I2cstart #3                                              'X GYRO
   I2cwbyte Mpuaddw , #3
   I2cwbyte 67 , #3
   I2crepstart #3
   I2cwbyte Mpuaddr , #3
   I2crbyte Tmp_gyrox(2) , Ack , #3
   I2crbyte Tmp_gyrox(1) , Ack , #3
   I2crbyte Tmp_gyroy(2) , Ack , #3
   I2crbyte Tmp_gyroy(1) , Ack , #3
   I2crbyte Tmp_gyroz(2) , Ack , #3
   I2crbyte Tmp_gyroz(1) , Nack , #3
   I2cstop #3

'(
  S1 = Str(gyrox)
  S = "Gx: " + Format(s1 , "+0000") ; " ";
  S1 = Str(gyroy)
  S = S + " Gy: " + Format(s1 , "+0000") ; " ";
  S1 = Str(Gyroz)
  S = S + " Gz: " + Format(s1 , "+0000") ; " ";
  Print S

  S1 = Str(xacc_pre)
  S = "Ax: " + Format(s1 , "+0000") ; " ";
  S1 = Str(yacc_pre)
  S = S + " Ay: " + Format(s1 , "+0000")
  Print S
')

'  Shift xAcc , Right , 5 , Signed                          '+-1024 bei 2g
'  Shift yAcc , Right , 5 , Signed
'  Shift zAcc , Right , 5 , Signed
'  Shift Meas_nick , Right , 5 , Signed                         '+-1024 bei 250/s
'  Shift Meas_roll , Right , 5 , Signed
'  Shift Yaw_gyro , Right , 5 , Signed
   'Meas_nick = Gyrox / 76.8                                 '65536/1024/(300/250) MPU gyro scaling equals adxrs300 scaling
   'Meas_roll = Gyroy / 76.8
   'Yaw_gyro = Gyroz / 76.8
'   Meas_nick = Gyrox / 38.4                                 'bei 500/s
'   Meas_roll = Gyroy / 38.4
'   Yaw_gyro = Gyroz / 38.4
   Meas_nick = Gyrox / 8.7                                  'bei 2000/s
   Meas_roll = Gyroy / -8.7                                 'GYRO-Rollachse negieren, damit Meas_roll positiv nach rechts korrekt ist
   Yaw_gyro = Gyroz / -8.7

   Xacc = Xacc_pre                                          '65536/1024 MPU acc scaling equals ADXL322 scaling
   Xacc_s = Xacc
   Yacc = -yacc_pre                                         'ACC-Rollachse negieren, damit Yacc positiv nach rechts korrekt ist
   Yacc_s = Yacc
   Zacc = Zacc_pre
   Zacc_s = Zacc


End Sub

'===GYRO========================================================================
Sub Gyro
If Old_state <> State Then                                  'compare state of last cycle with current state
  Error_roll = 0                                            'otherwise things would start mixing up...
  Error_nick = 0
  Meas_roll = 0
  Meas_nick = 0
  Error_roll_sum = 0
  Error_nick_sum = 0
  D_set_roll = 0
  D_set_nick = 0
  For I = 1 To 3
    Error_roll_old(i) = 0
    Error_roll_d(i) = 0
    Error_nick_old(i) = 0
    Error_nick_d(i) = 0
  Next
  If State = 2 Then
'    Meas_angle_roll = Acc_roll                              'when switching from acro mode to hover mode
'    Meas_angle_nick = Acc_nick                              'start with a "close to reality" angle
    Else
    Meas_angle_roll = 0
    Meas_angle_nick = 0
  End If
  Yaw_gyro_i = 0
  Yaw_diff = 0
End If

Old_state = State

'==================== ACRO MODE ====================
If State = 1 Then                                           'ACROBATIC MODE = Angular velocity control
  If Looper <= 15 Then                                      'for angular acceleration measurement
   Incr Looper                                              'acceleration will be calculated as the difference in velocity between
  Else                                                      'loop n and loop n+2
    Looper = 1
  End If

  '--Roll--
  If Roll_gyro_dir = 0 Then                                 'make gyro direction reversal possible
    Meas_roll = Roll_init - Meas_roll                       'subtract offset
  Elseif Roll_gyro_dir = 1 Then
    Meas_roll = Meas_roll - Roll_init                       'subtract offset
  End If
  Setpoint_roll = Sempf(rollchannel) * Lf                   'sempf(2) is roll stick position
  Error_roll = Meas_roll - Setpoint_roll                    'calculate difference between angular velocity and stick position
  Error_roll_d(looper) = Error_roll - Error_roll_old(looper)
  Error_roll_old(looper) = Error_roll
  D_set_roll = Error_roll_d(looper) * D_sens
  Error_roll_sum = Error_roll_sum + Error_roll              'integrate the above
  If Error_roll_sum > 1000000 Then
    Error_roll_sum = 1000000
  End If
  If Error_roll_sum < -1000000 Then
    Error_roll_sum = -1000000
  End If
  P_set_roll = Error_roll * P_sens                          'multiply with gain
  If Gyro_i_enable = 0 Then                                 'don't integrate when motors off
    Error_roll_sum = 0
  End If
  I_set_roll = Error_roll_sum * I_sens                      'multiply with gain


  '--Nick--
  If Nick_gyro_dir = 0 Then
    Meas_nick = Meas_nick - Nick_init
  Elseif Nick_gyro_dir = 1 Then
    Meas_nick = Nick_init - Meas_nick
  End If
  Setpoint_nick = Sempf(nickchannel) * Lf                   'sempf(3) is nick stick position
  Error_nick = Meas_nick - Setpoint_nick
  Error_nick_d(looper) = Error_nick - Error_nick_old(looper)
  Error_nick_old(looper) = Error_nick
  D_set_nick = Error_nick_d(looper) * D_sens
  Error_nick_sum = Error_nick_sum + Error_nick
  If Error_nick_sum > 1000000 Then
    Error_nick_sum = 1000000
  End If
  If Error_nick_sum < -1000000 Then
    Error_nick_sum = -1000000
  End If
  P_set_nick = Error_nick * P_sens
  If Gyro_i_enable = 0 Then
    Error_nick_sum = 0
  End If
  I_set_nick = Error_nick_sum * I_sens
End If

'==================== HOVER MODE ====================

If State = 2 Or State = 0 Then                              'HOVER MODE = Angle control
  If Looper <= 15 Then                                      'for angular acceleration measurement
    Incr Looper                                             'acceleration will be calculated as the difference in velocity between
  Else                                                      'loop n and loop n+2
    Looper = 1
  End If

  '--Roll--
  If Roll_gyro_dir = 0 Then                                 'make gyro direction reversal possible
    Meas_roll = Roll_init - Meas_roll                       'subtract offset
  Elseif Roll_gyro_dir = 1 Then
    Meas_roll = Meas_roll - Roll_init
  End If
  Meas_angle_roll = Meas_angle_roll + Meas_roll             'integrate gyro signal


  Meas_angle_roll = Meas_angle_roll * Gyro_influence        '0.99                  'take 0.99 of gyro integral and 0.01 of acc...
  Acc_roll_temp = Acc_roll_scaled * Acc_influence           '0.01
  Meas_angle_roll = Meas_angle_roll + Acc_roll_temp         '...and put these two together (complementary filtering)

  'sollwert = stickposition
  'istwert = gyrointegral
  'Fehler P = stickpos- gyrointegral
  'd-anteil wre sollwert = stickgeschw
  'istwert = gyrosignal

  Setpoint_roll = Sempf(rollchannel) * Lf                   'roll stick position * stick sensitivity
'p hover
  Error_roll = Meas_angle_roll - Setpoint_roll              'current angle minus desired angle (stick position)
'I hover
  Error_roll_sum = Error_roll_sum + Error_roll              'integral of an integral
'D hover
  Rollstick = Sempf(rollchannel) * 1                        'wie stark hat stickgeschw. einfluss.
  Error_roll_d(looper) = Rollstick - Error_roll_old(looper)
  Error_roll_old(looper) = Rollstick
  D_set_roll = Meas_roll - Error_roll_d(looper)
  D_set_roll = D_set_roll * D_sens

  If Error_roll_sum > 4000000 Then                          'integral clipping
    Error_roll_sum = 4000000
  End If
  If Error_roll_sum < -4000000 Then
    Error_roll_sum = -4000000
  End If

  P_set_roll = Error_roll * P_sens                          'multiply with gain
  If Gyro_i_enable = 0 Then
    Error_roll_sum = 0
  End If
  I_set_roll = Error_roll_sum * I_sens                      'multiply with gain
'  D_set_roll = Meas_roll * D_sens                           'multiply with gain

  '--Nick--
  If Nick_gyro_dir = 0 Then
    Meas_nick = Meas_nick - Nick_init
  Elseif Nick_gyro_dir = 1 Then
    Meas_nick = Nick_init - Meas_nick
  End If
  Meas_angle_nick = Meas_angle_nick + Meas_nick
  Meas_angle_nick = Meas_angle_nick * Gyro_influence        '0.99
  Acc_nick_temp = Acc_nick * Acc_influence                  '0.01
  Meas_angle_nick = Meas_angle_nick + Acc_nick_temp

  Setpoint_nick = Sempf(nickchannel) * Lf
'p hover
  Error_nick = Meas_angle_nick - Setpoint_nick
'i hover
  Error_nick_sum = Error_nick_sum + Error_nick
'd hover
  Nickstick = Sempf(nickchannel) * 1
  Error_nick_d(looper) = Nickstick - Error_nick_old(looper)
  Error_nick_old(looper) = Nickstick
  D_set_nick = Meas_nick - Error_nick_d(looper)
  D_set_nick = D_set_nick * D_sens


  If Error_nick_sum > 4000000 Then                          'integral clipping
    Error_nick_sum = 4000000
  End If
  If Error_nick_sum < -4000000 Then
    Error_nick_sum = -4000000
  End If

  P_set_nick = Error_nick * P_sens
  If Gyro_i_enable = 0 Then
    Error_nick_sum = 0
  End If
  I_set_nick = Error_nick_sum * I_sens
'  D_set_nick = Meas_nick * D_sens
End If


'--Yaw--
If Yaw_gyro_dir = 0 Then
 Yaw_gyro = Yaw_gyro - Yaw_init                             'subtract offset
Else
 Yaw_gyro = Yaw_init - Yaw_gyro
End If

Yaw_diff = Sempf(yawchannel) * Lf_yaw                       'yaw stick position
Yaw_diff = -yaw_diff

Yaw_diff = Yaw_diff - Yaw_gyro                              'stick position - current angular velocity

Yaw_gyro_i = Yaw_gyro_i + Yaw_diff                          'integral of the above
If Yaw_gyro_i > 32000 Then                                  'protect from overflow
 Yaw_gyro_i = 32000
End If
If Yaw_gyro_i < -32000 Then                                 'protect from overflow
 Yaw_gyro_i = -32000
End If

Yaw_gyro_scale = Yaw_diff * Yaw_p_sens                      'multiply with gain
If Gyro_i_enable = 0 Then                                   'integrate only when motors on
 Yaw_gyro_i = 0
End If
Yaw_gyro_i_scale = Yaw_gyro_i * Yaw_i_sens                  'multiply with gain
'Yaw_gyro_scale_int = Yaw_gyro_scale                         'convert single to integer
'Yaw_gyro_i_scale_int = Yaw_gyro_i_scale                     'convert single to integer
End Sub


'===ACCELEROMETER===============================================================
Sub Acc
If State <> 1 Then                                          'only used in HOVER MODE and when motors off

  Xacc = Xacc_pre                                           'read nick "angle"
  Yacc = Yacc_pre                                           'read roll "angle"
  If Xacc_dir = 1 Then                                      'make xacc direction reversable
    Xacc = Xacc_offset - Xacc                               '515 'these values are the ACC offsets. They were determined in flight (hovering in place)
  Else
    Xacc = Xacc - Xacc_offset
  End If
  If Yacc_dir = 1 Then
    Yacc = Yacc_offset - Yacc                               '524
  Else
    Yacc = Yacc - Yacc_offset
  End If

   'lowpass for accs...:
   'Wert = Wert * 0.9 + Neuer_wert * 0.1
'0.98
   Xacc_lp = Xacc_lp * 0.9
   Xacc = Xacc * 0.1
   Xacc_lp = Xacc_lp + Xacc

   Yacc_lp = Yacc_lp * 0.9
   Yacc = Yacc * 0.1
   Yacc_lp = Yacc_lp + Yacc

   Zacc_lp = Zacc_lp * 0.9
   Zacc = Zacc * 0.1
   Zacc_lp = Zacc_lp + Zacc


   Xacc_norm = Xacc_lp / Scalefactoracc
   Yacc_norm = Yacc_lp / Scalefactoracc
   Zacc_norm = Zacc_lp / Scalefactoracc

   'Acc_roll = Atn(xacc_norm / Sqr(yacc_norm ^ 2 + Zacc_norm ^ 2))
   'Acc_nick = Atn(yacc_norm / Sqr(xacc_norm ^ 2 + Zacc_norm ^ 2))
   Tmp1 = Yacc_norm * Yacc_norm
   Tmp2 = Zacc_norm * Zacc_norm
   Tmp3 = Tmp1 + Tmp2
   Tmp4 = Xacc_norm * -1                                    ' der Koeffizient ist richtig negativ (oder?)
   Tmp4 = Tmp4 / Sqr(tmp3)
   Acc_roll = Atn(tmp4)                                     'positiv ist nach rechts

   Tmp5 = Xacc_norm * Xacc_norm
   Tmp6 = Tmp5 + Tmp2
   Tmp7 = Yacc_norm / Sqr(tmp6)
   Acc_nick = Atn(tmp7)                                     'positiv ist nach hinten

   Acc_roll_scaled = Acc_roll * 57295.77951                 'acc: 0 = 0, 90 = 1.570796327 | gyrointegral: 90 = 90000
   Acc_nick_scaled = Acc_nick * 57295.77951

'   Acc_roll = Atn2(xacc_norm , Zacc_norm ) + 3.14159265359
'   Acc_roll_scaled = Rad2deg(acc_roll)                       '* 57295.77951

'   Acc_nick = Atn2(yacc_norm , Zacc_norm ) + 3.14159265359
'   Acc_nick_scaled = Rad2deg(acc_nick)                      '* 57295.77951


'  /* Calculate the angls based on the different sensors and algorithm */
'  accYangle = (atan2(accX,accZ)+PI)*RAD_TO_DEG;
'  accXangle = (atan2(accY,accZ)+PI)*RAD_TO_DEG;

'   double gyroXrate = (double)gyroX/131.0;
'  double gyroYrate = -((double)gyroY/131.0);
'  gyroXangle += gyroXrate*((double)(micros()-timer)/1000000); // Calculate gyro angle without any filter
'  gyroYangle += gyroYrate*((double)(micros()-timer)/1000000);

'   compAngleX = (0.93*(compAngleX+(gyroXrate*(double)(micros()-timer)/1000000)))+(0.07*accXangle); // Calculate the angle using a Complimentary filter
'  compAngleY = (0.93*(compAngleY+(gyroYrate*(double)(micros()-timer)/1000000)))+(0.07*accYangle);

'  kalAngleX = kalmanX.getAngle(accXangle, gyroXrate, (double)(micros()-timer)/1000000); // Calculate the angle using a Kalman filter
'  kalAngleY = kalmanY.getAngle(accYangle, gyroYrate, (double)(micros()-timer)/1000000);
'  timer = micros();

'  temp = ((double)tempRaw + 12412.0) / 340.0;



'//Converts the already acquired accelerometer data into 3D euler angles
'void Get_Accel_Angles()
'{
' Accel_yangle = 57.295 * Atan( - Accel_xout / Sqrt(pow(accel_yout , 2) + Pow(accel_zout , 2)));

' Accel_xangle = 57.295 * Atan( + Accel_yout / Sqrt(pow(accel_xout , 2) + Pow(accel_zout , 2)));
'}


'(

  If Debugger < 10 Then
  Debugger = Debugger + 1
  Else
  Debugger = 0
  Print_a = Meas_angle_nick                                 'Rad2deg(acc_roll)
'  Print_b = Acc_roll                                        'Rad2deg(acc_nick)
 '  Print_a = Rad2deg(acc_roll)
 '  Print_b = Rad2deg(acc_nick)
  Print_a_string = Fusing(print_a , "#.##")                 '6 langer string
'  Print_b_string = Fusing(print_b , "#.##")                 '6 langer string
  Print #2 , Print_a_string                                 '; Chr(009) ; Print_b_string
  End If
')

End If
End Sub

'(
Dta:                                                        'table lookup for dynamic lf (increasing maneuvrability when stick is out of the centre)
Data 5.8! , 6.1! , 6.3! , 6.5! , 6.8! , 7.2! , 7.6! , 8.1! , 8.7! , 9.4! , 10.2! , 11! , 12! , 13.6!
')

'===MIXER=======================================================================
Sub Mixer

' Werte vom Empfnger in Arbeitsvariablen schreiben, damit Empf(x) im IRQ neu beschrieben werden kann
'-------------------------------------------
'Empf(X) are filled in "getreceiver". They usually contain values ranging from -52 - +52.
'Empf(throttlechannel) is the throttle stick. it will be rescaled differently.
If Empf(throttlechannel) > -54 And Empf(throttlechannel) < 54 Then       'don't process values that can't be correct
  Sempf(throttlechannel) = Empf(throttlechannel) + 53       ' -> throttle from 1 to 105
  Sempf(throttlechannel) = Sempf(throttlechannel) * 2.4     '==> values ranging from 2 (stick at bottom) to 228 (full throttle)
End If

'Now nick, roll, yaw and idle up switch
If Empf(nickchannel) > -54 And Empf(nickchannel) < 54 Then  'don't process values that can't be correct
   Sempf(nickchannel) = Empf(nickchannel) * -1              ' convert to values ranging from -54 to +54 ...und noch negieren
End If
If Empf(rollchannel) > -54 And Empf(rollchannel) < 54 Then  'don't process values that can't be correct
      Sempf(rollchannel) = Empf(rollchannel)                'convert to values ranging from -54 to +54
End If
  If Empf(yawchannel) > -54 And Empf(yawchannel) < 54 Then  'don't process values that can't be correct
      Sempf(yawchannel) = Empf(yawchannel) * -1             ' convert to values ranging from -54 to +54 ...und noch negieren
End If
If Empf(5) > -54 And Empf(5) < 54 Then                      'don't process values that can't be correct
  Sempf(5) = Empf(5)                                        'convert to values ranging from -54 to +54
End If
If Empf(6) > -54 And Empf(6) < 54 Then                      'don't process values that can't be correct
  Sempf(6) = Empf(6)                                        'convert to values ranging from -54 to +54
End If

'-------------------------------------------
'Print #1 , "Sempf(1): " ; Sempf(1) ; " Sempf(2): " ; Sempf(2) ; " Sempf(3): " ; Sempf(3) ; " Sempf(4): " ; Sempf(4) ; " Sempf(5): " ; Sempf(5) ; " Sempf(6): " ; Sempf(6)

'ACRO MODE (angular velocity control, ACC = off)
   If Motorsenable = 1 Then                                 'only listen to receiver (and especially channel 5) when user enabled the motors in the GUI
     If Sempf(5) > 0 And Sempf(6) > 30 Then                 'switch1 AN und switch2 AN     -> State = 1
       Vorwahl = Idle_up                                    'minimum throttle
       Gyro_i_enable = 1                                    'start integrating the gyroscope signals
       Lf = Lf_acro
       P_sens = P_sens_acro                                 '0.45                                             'Gyro_P sensitivity roll and nick
       I_sens = I_sens_acro                                 '0.001                                            'Gyro_I Sensitivity roll and nick
       D_sens = D_sens_acro                                 'no D available in Acro mode (calculating it only yields noise)
       Yaw_p_sens = Yaw_p_sens_eep                          'Gyro_P Sensitivity yaw
       Yaw_i_sens = Yaw_i_sens_eep                          'Gyro_I Sensitivity yaw
       Motors_on = 1
       State = 1                                            'flight mode: acrobatic
     End If

'HOVER MODE (angle control, ACC = on)
     If Sempf(5) >= 31 And Sempf(6) < 30 Then               'switch1 AN und switch2 AUS     -> State = 2
       Vorwahl = Idle_up                                    'minimum throttle
       Gyro_i_enable = 1                                    'start integrating the gyroscope signals
       Lf = Lf_hover                                        '450                                                  'nick and roll sensitivity (much bigger, because a different control loop is used)
       P_sens = P_sens_hover                                '0.0025                                           'Gyro_P sensitivity roll and nick (corresponds to Gyro_I in acro mode)
       I_sens = I_sens_hover                                '0.0000015                                        'Gyro_I sensitivity roll and nick (this is a double integral, thats why the value is so low)
       D_sens = D_sens_hover                                '0.4                                              'Gyro_D sensitivity roll and nick (corresponds to Gyro_P in acro mode)
       Yaw_p_sens = Yaw_p_sens_eep                          'Gyro_P Sensitivity yaw
       Yaw_i_sens = Yaw_i_sens_eep                          'Gyro_I Sensitivity yaw
       Motors_on = 1
       State = 2                                            'flight mode: hover
     End If
     If Sempf(5) <= -30 Then                                'switch bottom = motors off
       If Sempf(throttlechannel) < 5 Then                   '!!!!!!!!!!!!!!!!!!!!!                 'only turn motors off when throttle stick is also on bottom
        Vorwahl = 0                                         'no minimum throttle = motors off
        Gyro_i_enable = 0                                   'do not integrate gyros anymore
        Motors_on = 0
        State = 0                                           'flight mode: off
        Lf = 0                                              'don't react to stick movements
        P_sens = 0                                          'don't react to gyros
        I_sens = 0                                          'don't react to gyros
        D_sens = 0                                          'don't react to gyros
        Yaw_p_sens = 0                                      'don't react to gyros
        Yaw_i_sens = 0                                      'don't react to gyros
       End If
     End If
   Else                                                     'if motors were not enabled in GUI or if EEprom empty: always stay in GUI mode
      Vorwahl = 0                                           'no minimum throttle = motors off
      Gyro_i_enable = 0                                     'do not integrate gyros anymore
      Motors_on = 0
      State = 0                                             'flight mode: off
      Lf = 0                                                'don't react to stick movements
      P_sens = 0                                            'don't react to gyros
      I_sens = 0                                            'don't react to gyros
      D_sens = 0                                            'don't react to gyros
      Yaw_p_sens = 0                                        'don't react to gyros
      Yaw_i_sens = 0                                        'don't react to gyros
   End If


'-Mix components-
If Motors_on = 1 Then                                       'only when motors are running
    'combine gyro PID
    'p_set_roll -100 bis 100 OK
    'i_set_roll -100 bis 100 OK
    'd_set_roll -100 bis 100 ok
    Roll_sgl = P_set_roll + I_set_roll
    Roll_sgl = Roll_sgl + D_set_roll

    Nick_sgl = P_set_nick + I_set_nick
    Nick_sgl = Nick_sgl + D_set_nick

    Yaw_sgl = Yaw_gyro_scale + Yaw_gyro_i_scale
'    If State = 2 Then                                       'add DD term in hover mode
'      Roll_sgl = Roll_sgl + Dd_set_roll
'      Nick_sgl = Nick_sgl + Dd_set_nick
'    End If



'Hier Limits Anpassen                          '!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
'erstmal gucken was berhaupt ankommt...
'sempf(1) geht von 0 bis 255 (eher von 2 bis 212 mit DX6i)
'motorwerte 29000 bis 60400 = 31400 schritte
'
'Motorzuordnungen Quad
'vorne links  : 3              (3)   (2)
'vorne rechts : 2                 \ /
'hinten rechts: 1                 / \
'hinten links : 4              (4)   (1)


   '-MOTOR 3-     Links Vorne
   Ms_3_i = Sempf(throttlechannel) + Vorwahl
   If Ms_3_i > 250 Then Ms_3_i = 250
   Ms_3_i = Ms_3_i + Roll_sgl
   Ms_3_i = Ms_3_i - Nick_sgl
   Ms_3_i = Ms_3_i + Yaw_sgl

                                          '-MOTOR 2-     Rechts Vorne
                                          Ms_2_i = Sempf(throttlechannel) + Vorwahl
                                          If Ms_2_i > 250 Then Ms_2_i = 250
                                          Ms_2_i = Ms_2_i - Roll_sgl
                                          Ms_2_i = Ms_2_i - Nick_sgl
                                          Ms_2_i = Ms_2_i - Yaw_sgl

   '-MOTOR 4-     Links Hinten
   Ms_4_i = Sempf(throttlechannel) + Vorwahl
   If Ms_4_i > 250 Then Ms_4_i = 250
   Ms_4_i = Ms_4_i + Roll_sgl
   Ms_4_i = Ms_4_i + Nick_sgl
   Ms_4_i = Ms_4_i - Yaw_sgl
                                          '-MOTOR 1-     Rechts Hinten
                                          Ms_1_i = Sempf(throttlechannel) + Vorwahl
                                          If Ms_1_i > 250 Then Ms_1_i = 250
                                          Ms_1_i = Ms_1_i - Roll_sgl
                                          Ms_1_i = Ms_1_i + Nick_sgl
                                          Ms_1_i = Ms_1_i + Yaw_sgl


Else                                                        'motors off
   Ms_1_i = 0
   Ms_2_i = 0
   Ms_3_i = 0
   Ms_4_i = 0
End If

 '-Kanal 6- (DX6i)
'Achtung!!!  sempf(6) wird grad fr ACRO/HOVER verwendet (die DX6i hat keinen 3-Positionen.Schalter auf Kanal 5)
' Hier wird nur die gelbe LED geschaltet, da "state" bereits weiter oben bei 'HOVER MODE bzw 'ACRO MODE korrekt gesetzt wird
If Led_gelb_merker = 0 Then                                 ' nur bearbeiten, wenn nicht im ACC-Lernmodus
   If Sempf(6) > 50 Then
      Led_yellow = 1                                        ' ACRO
   Else
      Led_yellow = 0                                        ' HOVER
   End If
End If

End Sub


'===MOTORS I2C==================================================================
Sub Send_mots

If Ms_1_i > 255 Then Ms_1_i = 255                           'cap motor signals (upper limit = 255)
If Motors_on = 1 Then
  If Ms_1_i < Vorwahl Then Ms_1_i = Vorwahl                 'cap motor signals (lower limit = vorwahl)
End If
If Ms_1_i < 0 Then Ms_1_i = 0                               'cap motor signals (lower limit = 0)

If Ms_2_i > 255 Then Ms_2_i = 255                           'cap motor signals (upper limit = 255)
If Motors_on = 1 Then
  If Ms_2_i < Vorwahl Then Ms_2_i = Vorwahl                 'cap motor signals (lower limit = vorwahl)
End If
If Ms_2_i < 0 Then Ms_2_i = 0                               'cap motor signals (lower limit = 0)

If Ms_3_i > 255 Then Ms_3_i = 255                           'cap motor signals (upper limit = 255)
If Motors_on = 1 Then
  If Ms_3_i < Vorwahl Then Ms_3_i = Vorwahl                 'cap motor signals (lower limit = vorwahl)
End If
If Ms_3_i < 0 Then Ms_3_i = 0                               'cap motor signals (lower limit = 0)

If Ms_4_i > 255 Then Ms_4_i = 255                           'cap motor signals (upper limit = 255)
If Motors_on = 1 Then
  If Ms_4_i < Vorwahl Then Ms_4_i = Vorwahl                 'cap motor signals (lower limit = vorwahl)
End If
If Ms_4_i < 0 Then Ms_4_i = 0                               'cap motor signals (lower limit = 0)

Ms_1 = Ms_1_i * 122
Ms_1 = Ms_1 + 29000
Ms_2 = Ms_2_i * 122
Ms_2 = Ms_2 + 29000
Ms_3 = Ms_3_i * 122
Ms_3 = Ms_3 + 29000
Ms_4 = Ms_4_i * 122
Ms_4 = Ms_4 + 29000


'failure will be 40 after 0.8s when Deltang Rx31 doesn't transmit data

'if there are NO problems with the receiver and shrediquette was programmed: run motors
If Failure < 40 And Motorsenable = 1 Then

'Motorzuordnungen Quad
'vorne links  : 3              (3)   (2)
'vorne rechts : 2                 \ /
'hinten rechts: 1                 / \
'hinten links : 4              (4)   (1)

Tcd0_ccc = Ms_4                                             ' MOT4 im Schaltbild
Tcd0_ccd = Ms_1                                             ' MOT3 im Schaltbild
Tcd1_cca = Ms_2                                             ' MOT2 im Schaltbild
Tcd1_ccb = Ms_3                                             ' MOT1 im Schaltbild

Else                                                        'if there are problems with the receiver: turn off motors
   Tcd0_ccc = 29000                                         ' MOT4 im Schaltbild
   Tcd0_ccd = 29000                                         ' MOT3 im Schaltbild
   Tcd1_cca = 29000                                         ' MOT2 im Schaltbild
   Tcd1_ccb = 29000                                         ' MOT1 im Schaltbild

   If Failure > 240 Then                                    'motorpiepsen zum wiederfinden.... (ESC piepst ohne PPM-Signnal)
      Tcd0_ccc = 0                                          ' MOT4 im Schaltbild
      Tcd0_ccd = 0                                          ' MOT3 im Schaltbild
      Tcd1_cca = 0                                          ' MOT2 im Schaltbild
      Tcd1_ccb = 0                                          ' MOT1 im Schaltbild
   End If
End If

End Sub

'===LEDs========================================================================
Sub Led
If Ledcount < 500 Then
   Incr Ledcount
   If Ledcount = 135 Or Ledcount = 140 Or Ledcount = 205 Or Ledcount = 210 Then       'flash LEDs
      Toggle Led_vorn
      Toggle Led_hinten
   End If
  If Lowvoltage = 0 Then
    If State > 0 Then                                       'flight modes 1 & 2 get a different LED signal
      If Ledcount = 130 Or Ledcount = 135 Or Ledcount = 230 Or Ledcount = 235 Then       'flash LEDs
        Toggle Led_red
      End If
      If Ledcount = 100 Or Ledcount = 105 Or Ledcount = 200 Or Ledcount = 205 Then
        Toggle Led_blue
      End If
'      If Ledcount = 160 Or Ledcount = 165 Or Ledcount = 260 Or Ledcount = 265 Then
'        Toggle Led_yellow
'      End If
'      If Ledcount = 470 Then
'        Toggle Led_grn
'      End If
    Else                                                    'state = 0 ==> ready for GUI connection
      If Ledcount = 100 Or Ledcount = 105 Or _
         Ledcount = 200 Or Ledcount = 205 Or _
         Ledcount = 300 Or Ledcount = 305 Then
         Toggle Led_red
         Toggle Led_blue
         'Toggle Led_yellow
         'Toggle Led_grn
      End If
    End If
  End If
  If Lowvoltage = 1 Then                                    'when battery is low, blink the LEDs in an annoying manner

    If Ledcount = 100 Or Ledcount = 105 Or Ledcount = 200 Or Ledcount = 205 Then       'Or _
       'Ledcount = 300 Or Ledcount = 305 Or Ledcount = 400 Or Ledcount = 405 Then       'flash Positions LEDs
      Toggle Led_vorn
      Toggle Led_hinten
    End If

    If Blinker < 30 Then
        Incr Blinker
    Else
      Blinker = 1
      Toggle Led_red
      Toggle Led_blue
      'Toggle Led_yellow
    End If
'   Reset Led_grn
  End If

Else
    Ledcount = 1
    Reset Led_red
    Reset Led_blue
    'Reset Led_yellow
    ' alle 500 Runden die Pos-LEDs wieder aus machen, dann kann der Rest machen was er will
    Reset Led_vorn
    Reset Led_hinten
End If

End Sub

'===VOLTAGE=====================================================================
Sub Voltage

If Ledcount = 500 Then                                      'we'll only check voltage every 500 cycles (==> about 1 Hz)
' Vollausschlag ADC ist 4096 (12 bit)
' Spannungsteiler 10k/10k, Referenz ist "Intvcc", also nach Datenblatt VCC/1,6 = 3,3 V/1,6 = 2,0625 V
' Ref = 2,0625 V <-> 4096
' 0,50354 mV / Digit -> 3,8 V <->
' gemessene Werte: 4,2 V -> 2047, 3,8 V  -> 1996, 3,6 V -> 1904

  Spann = Getadc(adca , 0)
  'Print "V= " ; Spann
  'ADC bei 3,3 V Versorgung des Atmel
  ' 4,28 V -> 654
  ' 4,25 V -> 650
  ' 4,16 V -> 639
  ' ...
  ' 3,40 V -> 520
  ' 3,36 V -> 514
  ' 3,29 V -> 504

  Spannmittel = Spann + Spann_alt                           'very unprofessional moving average filter
  Spannmittel = Spannmittel + Spann_alt2
  Spannmittel = Spannmittel + Spann_alt3
  Spannmittel = Spannmittel / 4

  Spann_alt3 = Spann_alt2
  Spann_alt2 = Spann_alt
  Spann_alt = Spann
                                                            ' Voltage_warn ist bei 63 in der GUI 252 (63*4) fr 3,36 V
  Spannmittel = Spannmittel / 2                             ' musste beim xNQ durch 2 geteilt werden, wegen Spannungsteiler

'  Print "Spannmittel= " ; Spannmittel
'  Print "Voltage_warn= " ; Voltage_warn
'  Print "State=" ; State

  If Spannmittel < Voltage_warn Then                        '795 => 9.9V
    Lowvoltage = 1                                          'set low-voltage bit when voltage is low
    If Sempf(5) > -20 Then                                  'Speaker nur anschalten wenn Wahlschalter nicht auf aus steht
         Speakeron = 1                                      'Nils-Speaker
         Speakerduration = 30                               'Nils-Speaker:  jeden 250ten zyklus
         Silenceduration = 30                               'Nils-Speaker: Dauer der Stille
         Speakerbeeps = 9                                   'Nils-Speaker: Anzahl der Pieps 4=unendlich
    End If
  Else
    Lowvoltage = 0
  End If
End If

End Sub

'===READ RX=====================================================================
Getreceiver:
   'Toggle Led_hinten
   Failure = 0                                              ' Empfang ok
   '1. steigende Flanke startet den Timer, die 2. steigende Flanke speichert den gemessenen Wert in Empf(1)
   If Channel > 0 And Channel < 7 Then
     Empftmp(channel) = Tcc0_cnt - 65090                    ' mit 65090 liegen der Werte ca. zwischen 48..152, Mitte bei 100
     Empf(channel) = Empftmp(channel) - 100
'     Empf(channel) = Tcc0_cnt - 65190
   End If
   Tcc0_cnt = 65000
   Incr Channel
Return

'-------------------------------------------------------------------------------
Detectrxpause:
   'Toggle Led_vorn
   Channel = 0                                              ' 0 ist korrekt, erst der 2. IRQ kann zur Zeitmessung dienen
   If Failure < 50 Then
      Failure = Failure + 1                                 ' Empfang gestrt -> Failure erhhen
   End If

Return

'===SPEAKER=====================================================================
Sub Speaker
 If Speakeron = 1 And Speakerbeeps > 0 Then                 'If a speaker command is present and beeps are left
   If Speakercount < Speakerduration Then                   'how long is a single beep
     Incr Speakercount
     Set Speakerport                                        'set speaker output
     Silencecount = 0                                       'reset elapsed silencetime
   Else
     Reset Speakerport                                      'reset speaker output
     Incr Silencecount
     If Silencecount > Silenceduration Then                 'how long is the silence between two beeps
      Speakercount = 0                                      'reset elapsed beep time
      Decr Speakerbeeps                                     'this is the end of a beep silence cycle, decrease the amoutn of beeps by one each cycle
      End If
   End If
 Else
   Reset Speakerport                                        'Reset speaker output if no speaker command
 End If

End Sub

'===GUI=========================================================================
Sub Guiconnection                                           'RS232 link to the GUI
#if Run_gui = 1
   If State >= 0 Then                                       'display GUI data even when motors are running - do this only for debug purposes
#else
   If State = 0 Then                                        'don't listen to serial commands when motors running!
#endif

 If Ischarwaiting(#1) > 0 Then
   Input #1 , A Noecho
   Read_empfangen = Instr(a , "cr!")
   Sensors_empfangen = Instr(a , "cs!")
   Input_empfangen = Instr(a , "ci!")
   Reset_empfangen = Instr(a , "reset!")                    ' fr Firmware update - nicht bentigt, kein Bootloader implementiert
   If Reset_empfangen = 1 Then
     Reset_empfangen = 0
     Waitms 100
     'Goto $3c00                                             '$3c00 -> m328p; $1c00 -> m168
   End If
   '--------------------------------
   If Read_empfangen <> 0 Then
     Read_empfangen = 0
     Waitms 25
     Print #1 , "s#p!"                                      'tell pc that data will follow
     Printbin Var(1) ; 33                                   'print the list of parameters that can be modified
   End If
   '--------------------------------
   If Sensors_empfangen <> 0 Then
     Sensors_empfangen = 0
     Print #1 , "ss!"                                       'tell pc that sensor data will follow
     'rescale the readings from the sensors to a value ranging from 0 to 255
    ' and put these values in an array "sensor(X)"
     Meas_roll_gui = Meas_roll / 2
     If Meas_roll_gui > 127 Then Meas_roll_gui = 127
     If Meas_roll_gui < -127 Then Meas_roll_gui = -127
     Meas_roll_gui = Meas_roll_gui + 127
     Sensor(1) = Meas_roll_gui

     Meas_angle_roll_gui = Meas_angle_roll / 200
     If Meas_angle_roll_gui > 127 Then Meas_angle_roll_gui = 127
     If Meas_angle_roll_gui < -127 Then Meas_angle_roll_gui = -127
     Meas_angle_roll_gui = Meas_angle_roll_gui + 127
     Sensor(2) = Meas_angle_roll_gui

     Yacc_gui = Yacc / 200                                  '200
     If Yacc_gui > 127 Then Yacc_gui = 127
     If Yacc_gui < -127 Then Yacc_gui = -127
     Yacc_gui = Yacc_gui + 127
     Sensor(3) = Yacc_gui

     Meas_nick_gui = Meas_nick / 2
     If Meas_nick_gui > 127 Then Meas_nick_gui = 127
     If Meas_nick_gui < -127 Then Meas_nick_gui = -127
     Meas_nick_gui = Meas_nick_gui + 127
     Sensor(4) = Meas_nick_gui

     Meas_angle_nick_gui = Meas_angle_nick / 200
     If Meas_angle_nick_gui > 127 Then Meas_angle_nick_gui = 127
     If Meas_angle_nick_gui < -127 Then Meas_angle_nick_gui = -127
     Meas_angle_nick_gui = Meas_angle_nick_gui + 127
     Sensor(5) = Meas_angle_nick_gui

     Xacc_gui = Xacc / 200                                  '200
     If Xacc_gui > 127 Then Xacc_gui = 127
     If Xacc_gui < -127 Then Xacc_gui = -127
     Xacc_gui = Xacc_gui + 127
     Sensor(6) = Xacc_gui

     Yaw_gyro_gui = Yaw_gyro / 2
     If Yaw_gyro_gui > 127 Then Yaw_gyro_gui = 127
     If Yaw_gyro_gui < -127 Then Yaw_gyro_gui = -127
     Yaw_gyro_gui = Yaw_gyro_gui + 127
     Sensor(7) = Yaw_gyro_gui

     Sempf_gui(1) = Sempf(throttlechannel)                  '  * 1.1
      If Sempf_gui(1) > -54 And Sempf_gui(1) < 54 Then      'don't process values that can't be correct
        Sempf_gui(1) = Sempf_gui(1) + 53
        Sempf_gui(1) = Sempf_gui(1) * 2.4                   '==> values ranging from 3 (stick at bottom) to 228 (full throttle)
      End If
     Sensor(8) = Sempf_gui(1) * 1.1

     Sempf_gui(2) = Sempf(rollchannel) + 39
     Sempf_gui(2) = Sempf_gui(2) * 3.2
     Sensor(9) = Sempf_gui(2)

     Sempf_gui(3) = Sempf(nickchannel) + 39
     Sempf_gui(3) = Sempf_gui(3) * 3.2
     Sensor(10) = Sempf_gui(3)

     Sempf_gui(4) = Sempf(yawchannel) + 39
     Sempf_gui(4) = Sempf_gui(4) * 3.2
     Sensor(11) = Sempf_gui(4)

     Sempf_gui(5) = Sempf(5) + 39
     Sempf_gui(5) = Sempf_gui(5) * 3.2
     Sensor(12) = Sempf_gui(5)

     Voltage_gui = Spannmittel / 4
     'Voltage_gui = Voltage_gui - 256
     Sensor(13) = Voltage_gui

     Printbin #1 , Sensor(1) ; 13
   End If
   '--------------------------------
   If Input_empfangen <> 0 Then                             'pc wants to transfer parameters
      Input_empfangen = 0
      Set Led_yellow
      Inputbin Var(1) , 33                                  'read list of 33 parameters from PC

      Waitms 100

      For I = 1 To 33
         Eramvariable(i) = Var(i)                           ' RAM-Variablen ins EEPROM schreiben
      Next

      Waitms 50
      Reset Led_yellow
      Geteeprom
   End If
 End If
End If
End Sub

'===READ AND PROCESS EEPROM=====================================================
Sub Geteeprom
Set Led_yellow                                              'Led_red
Waitms 100

For I = 1 To 33
  'Readeeprom Var(i)                                         ', I
   Var(i) = Eramvariable(i)                                 ' EEPROM auslesen und in RAM-Variablen schreiben
Next

Convert_vars:
Motorsenable = Var(1)
Roll_gyro_dir = Var(2)
Nick_gyro_dir = Var(3)
Yaw_gyro_dir = Var(4)
Xacc_dir = Var(5)
Yacc_dir = Var(6)
P_sens_acro = Var(7) / 255
I_sens_acro = Var(8) / 25500
P_sens_hover = Var(9) / 25500
I_sens_hover = Var(10) / 25500000                           'decrease factor to  12800000
D_sens_hover = Var(11) / 255
Yaw_p_sens_eep = Var(12) / 255
Yaw_i_sens_eep = Var(13) / 25500
Acc_influence = Var(14) / 3000
Gyro_influence = 1 - Acc_influence
Xacc_scale = Var(15)
Yacc_scale = Var(16)
'Lf_acro = Var(17) / 25.5
'Lf_hover = Var(18) * 4
'Lf_yaw = Var(19) / 17
Lf_boost = Var(20)
Idle_up = Var(21) / 5
Voltage_warn = Var(22) * 4                                  ' the "Voltage Warning Level" value from the GUI  multiplied by 4
Xacc_offset = Var(23)                                       ' + 384
Yacc_offset = Var(24)                                       ' + 384
Throttlechannel = Var(25)
Nickchannel = Var(26)
Rollchannel = Var(27)
Yawchannel = Var(28)
D_sens_acro = Var(29) / 50
Dd_sens = Var(30) / 50

'if eeprom is empty: vars will be 255. That can cause weird things ==> set all vars to 0
If Roll_gyro_dir > 100 Or Nick_gyro_dir > 100 Or Yaw_gyro_dir > 100 Or Xacc_dir > 100 Or Yacc_dir > 100 Or Throttlechannel > 4 Or Rollchannel > 4 Or Nickchannel > 4 Or Yawchannel > 4 Then
  For I = 1 To 33
    Var(i) = 0                                              'set to zero
  Next
'  Var(25) = 3                                               ' Throttle, Kanalzuordnung bei Graupner mc-15, mode1 (Gas links)
'  Var(26) = 1                                               ' Nick, Kanalzuordnung bei Graupner mc-15, mode1
'  Var(27) = 2                                               ' Roll, Kanalzuordnung bei Graupner mc-15, mode1
'  Var(28) = 4                                               ' Yaw, Kanalzuordnung bei Graupner mc-15, mode1
  Var(25) = 1                                               ' Throttle, Kanalzuordnung bei Spektrum DX6i, mode1 (Gas links)
  Var(26) = 3                                               ' Nick, Kanalzuordnung bei Spektrum DX6i, mode1
  Var(27) = 2                                               ' Roll, Kanalzuordnung bei Spektrum DX6i, mode1
  Var(28) = 4                                               ' Yaw, Kanalzuordnung bei Spektrum DX6i, mode1
  Goto Convert_vars                                         'and reinitialize the variables
End If

   Var(25) = 1                                              ' Throttle, Kanalzuordnung bei Spektrum DX6i, mode1 (Gas links)
   Var(26) = 3                                              ' Nick, Kanalzuordnung bei Spektrum DX6i, mode1
   Var(27) = 2                                              ' Roll, Kanalzuordnung bei Spektrum DX6i, mode1
   Var(28) = 4                                              ' Yaw, Kanalzuordnung bei Spektrum DX6i, mode1
   Throttlechannel = Var(25)
   Nickchannel = Var(26)
   Rollchannel = Var(27)
   Yawchannel = Var(28)

Reset Led_yellow                                            'Led_red
End Sub